/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.commerce.common;

import org.apache.jackrabbit.util.ISO8601;
import org.apache.sling.api.resource.ValueMap;

import java.lang.reflect.Array;
import java.util.Calendar;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

/**
 * <code>ValueMapDecorator</code> decorates another {@link Map} to provide a basic implementation
 * for the additional methods of a {@link org.apache.sling.api.resource.ValueMap}.
 *
 * This class is similar to {@link org.apache.sling.api.wrappers.ValueMapDecorator}, but provides
 * {@link javax.jcr.Value} semantics for dates.
 */
public class ValueMapDecorator implements ValueMap {

    /**
     * underlying map
     */
    private final Map<String, Object> base;

    /**
     * Creates a new wrapper around a given map.
     * @param base wrapped object
     */
    public ValueMapDecorator(Map<String, Object> base) {
        this.base = base;
    }

    /**
     * {@inheritDoc}
     */
    public <T> T get(String name, Class<T> type) {
		return null;
	}

    /**
     * Converts the object to the given type.
     * @param obj object
     * @param type type
     * @return the converted object
     */
    @SuppressWarnings("unchecked")
    private <T> T convert(Object obj, Class<T> type) {
		return null;
	}

    /**
     * Converts the object to an array of the given type
     * @param obj the object or object array
     * @param type the component type of the array
     * @return and array of type T
     */
    private <T> T[] convertToArray(Object obj, Class<T> type) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings("unchecked")
    public <T> T get(String name, T defaultValue) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public int size() {
		return 0;
	}

    /**
     * {@inheritDoc}
     */
    public boolean isEmpty() {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public boolean containsKey(Object key) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public boolean containsValue(Object value) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public Object get(Object key) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Object put(String key, Object value) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Object remove(Object key) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public void putAll(Map<? extends String, ?> t) {
	}

    /**
     * {@inheritDoc}
     */
    public void clear() {
	}

    /**
     * {@inheritDoc}
     */
    public Set<String> keySet() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Collection<Object> values() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public Set<Entry<String, Object>> entrySet() {
		return null;
	}

    @Override
    public String toString() {
		return null;
	}
}
