/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.contentinsight;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

/**
 * A <code>ProviderSettingsProvider</code> provides required settings for
 * Content Insight provider implementations, e.g. remote service URLs or
 * authentication tokens. 
 */
public interface ProviderSettingsProvider {

    /**
     * Get the provider's unique name.
     */
    public String getName() {
		return null;
	}

    /**
     * Get the settings for a resource, e.g. a page.
     */
    public ValueMap getSettings(Resource resource) {
		return null;
	}

    /**
     * Check if provider is active for the given resource.
     */
    public boolean isActive(Resource resource) {
		return false;
	}
}
