/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ************************************************************************/
package com.adobe.cq.dam.index.builder;

import com.adobe.cq.dam.index.builder.api.IndexDefinition;
import com.google.common.collect.ImmutableMap;
import org.apache.jackrabbit.JcrConstants;
import org.apache.jackrabbit.oak.plugins.index.IndexConstants;
import org.apache.jackrabbit.oak.plugins.index.lucene.IndexFormatVersion;
import org.apache.jackrabbit.oak.plugins.index.lucene.LuceneIndexConstants;
import org.apache.sling.api.resource.PersistenceException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * Represents Oak Lucene Index Definition
 */
public class LuceneIndexDefinition implements IndexDefinition {

    private static Logger log = LoggerFactory.getLogger(LuceneIndexDefinition.class);

    String indexName;
    List<IndexRule> indexRules;
    List<AggregationRule> aggregationRules;

    /**
     * Initializes LuceneIndexDefinition with given aggregation and index rules
     * @param indexName indexName with which the index will be saved in repository
     * @param aggregationRules list of AggregationRule
     * @param indexRules list of IndexRule
     */
    public LuceneIndexDefinition(String indexName,
                                 List<AggregationRule> aggregationRules, List<IndexRule> indexRules) {
        this.indexName = indexName;
        this.aggregationRules = aggregationRules;
        this.indexRules = indexRules;
    }

    /**
     * {@inheritDoc}
     */
    public boolean build(Resource resource) {
		return false;
	}

    /**
     * {@inheritDoc}
     */
    public boolean build(Resource resource, boolean reindex) {
		return false;
	}
}
