/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.mobile.platform;

import aQute.bnd.annotation.ConsumerType;
import org.apache.sling.commons.json.io.JSONWriter;

/**
 * A <code>MobileAppsInfoProvider</code> is used to provide information
 * for a mobile resource.
 */
@ConsumerType
public interface MobileAppsInfoProvider {

    /**
     * Use the writer to append any new data.
     *
     * @param writer the writer to use to generate the additional json.
     * @param mobileResource the mobile resource.
     */
    public void updateInfo(JSONWriter writer, MobileResource mobileResource) {
	}
}
