/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.learningpath.model.api;

import java.util.List;
import java.util.Map;

import org.apache.sling.api.resource.PersistenceException;

import com.adobe.cq.social.enablement.exceptions.EnablementException;
import com.adobe.cq.social.enablement.resource.model.api.EnablementResourceModel;

public interface EnablementLearningPathModel extends EnablementResourceModel {

    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/model/learningpath";
    public static final String ENABLEMENT_TYPE_VALUE = "learningpath";

    public static final String RESOURCE_LIST = "se_resourcelist";
    public static final String PREREQUISITES = "se_prerequisites";
    public static final String ENFORCE_ORDER = "se_enforce-order";

    /**
     * @return
     */
    public boolean getEnforceOrder() {
		return false;
	}

    public void setEnforceOrder(boolean enforceOrder) throws EnablementException {
	}

    /**
     * @return
     * @throws PersistenceException
     */
    public EnablementLearningPathResources acquireReferencedResources() throws PersistenceException {
		return null;
	}

    /**
     * @return
     */
    public List<Object> getItems() {
		return null;
	}

    /**
     * @return
     */
    public int getTotalSize() {
		return 0;
	}

    public void setPrerequisites(Map<String, Object> map) throws EnablementException {
	}

    /**
     * To get the Pre-req Learning Paths
     * @return
     */
    public List<EnablementLearningPathPrerequisite> getPrerequisites() {
		return null;
	}
}
