/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *******************************************************************************/
package com.adobe.cq.social.enablement.reporting.model.api;

import java.util.Calendar;

public interface EnablementResourceUserReportModel extends EnablementResourceReportModel {

    public static final String RESOURCE_TYPE = "social/enablement/components/hbs/model/resource/report/user";

    public static final String PROFILE_PATH = "profile";
    public static final String FIRST_NAME = "givenName";
    public static final String LAST_NAME = "familyName";
    public static final String EMAIL = "email";

    /**
     * Gets the user id
     * @return user name
     */
    public String getUserId() {
		return null;
	}

    /**
     * Gets the user first name
     * @return user first name
     */
    public String getFirstName() {
		return null;
	}

    /**
     * Gets the user last name
     * @return user last name
     */
    public String getLastName() {
		return null;
	}

    /**
     * Gets the start date.
     * @return the start date
     */
    public String getStartDate() {
		return null;
	}

    /**
     * Gets the completion status.
     * @return the completion status (e.g. not assigned, not attempted, in progress, 1-100%, completed).
     */
    public String getCompletionStatus() {
		return null;
	}

    /**
     * Gets the assignment status.
     * @return the assignment status (e.g. new, not attempted, in progress, completed).
     */
    public String getAssignmentStatus() {
		return null;
	}

    /**
     * Gets the complete date.
     * @return
     */
    public String getCompleteDate() {
		return null;
	}

    /**
     * Gets the complete date object.
     * @return
     */
    public Calendar getCompleteDateObject() {
		return null;
	}

    /**
     * Gets the score.
     * @return the score
     */
    public String getScore() {
		return null;
	}

    /**
     * Gets the success status.
     * @return the success status
     */
    public String getSuccessStatus() {
		return null;
	}

    /**
     * Gets the user's total number of comments on the assignment
     * @return number of comments
     */
    public long getCommentCount() {
		return 0L;
	}

    /**
     * Gets the user's rating on the assignment
     * @return rating
     */
    public double getRating() {
		return 0.0d;
	}

    /**
     * Gets the width to specify for the rating stars
     * @return rating width
     */
    public double getRatingWidth() {
		return 0.0d;
	}

    /**
     * If the completion status is a percentage, we want to render a progress bar instead of a string.
     * @return true iff the completion status is a percentage
     */
    public boolean isPercentageStatus() {
		return false;
	}

    /**
     * Determine if this enrollment is for a user who is assigned to a resource as opposed to someone who access the
     * resource via the catalog. Or, in the case of the group assignment report, the user may be part of a group but
     * not assigned to the resource.
     * @return true iff the user is assigned to the resource
     */
    public boolean isAssigned() {
		return false;
	}

    /**
     * @return for videos, returns the state representing the parts of the video that have been watched by the logged
     *         in user, otherwise returns null
     */
    public String getVideoState() {
		return null;
	}

    /**
     * @return for videos, returns the resume position in milliseconds for the logged in user, otherwise returns null
     */
    public String getVideoResumePosition() {
		return null;
	}

    /**
     * @return for videos, returns the number of total milliseconds that the user has cumulatively watched in this
     *         video, otherwise returns null
     */
    public String getVideoProgress() {
		return null;
	}

    /**
     * @return for videos, returns the percentage of the video that has been cumulatively watched, otherwise returns
     *         null
     */
    public String getPercentComplete() {
		return null;
	}

    /**
     * Set the user's completion status for this resource.
     * @param completionStatus
     */
    public void setCompletionStatus(final String completionStatus) {
	}

    /**
     * Set the user's success status for this resource.
     * @param successStatus
     */
    public void setSuccessStatus(final String successStatus) {
	}

    /**
     * Set the user's score for this resource.
     * @param score
     */
    public void setScore(final int score) {
	}

    /**
     * Set the user's completion/progress state for this video resource.
     * @param state
     */
    public void setVideoState(final String state) {
	}

    /**
     * Set the user's resume position for this video resource.
     * @param resume
     */
    public void setVideoResume(final String resume) {
	}

    /**
     * Increment the counter for the corresponding property on this user resource report (and increments the property
     * for resource aggregation as well).
     */
    public void incrementCount(final String propertyName) {
	}
}
