/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.enablement.resource.endpoints.api;

import java.util.List;

import com.adobe.cq.social.enablement.resource.model.api.EnablementResourceModel;
import com.adobe.cq.social.scf.Operation;
import com.adobe.cq.social.scf.OperationExtension;

/**
 * Hook operation to enable clients register callback during an execution of an operation.
 */
public interface EnablementResourceModelOperationExtension extends OperationExtension<EnablementResourceModel> {
    /**
     * Operation types.
     */
    public enum EnablementResourceModelOperation implements Operation {
        /** Follow Operation. */
        CREATE, PUBLISH, UPDATE, DELETE, REPORT
    };

    /**
     * Get the list of operations that this operation extension is interested in.
     * @return a list of {@link EnablementResourceModelOperation}
     */
    @Override
    List<EnablementResourceModelOperation> getOperationsToHookInto() {
		return null;
	}
}
