/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.enablement.resource.endpoints.api;

import org.apache.sling.api.SlingHttpServletRequest;

import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.SocialComponent;

public interface EnablementResourceModelOperations {

    /**
     * Create a new enablement resource on the specified {@link SlingHttpServletRequest}
     * @param request the client request
     * @param allowedKeys
     * @return the published {@link SocialComponent}
     * @throws OperationException if there is an error occurs
     */
    SocialComponent create(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Update an existing enablement resource on the specified {@link SlingHttpServletRequest}
     * @param request the client request
     * @param allowedKeys
     * @return the published {@link SocialComponent}
     * @throws OperationException if there is an error occurs
     */
    SocialComponent update(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Update the report of a enablement resource on the specified {@link SlingHttpServletRequest}
     * @param request the client request
     * @param allowedKeys
     * @return the published {@link SocialComponent}
     * @throws OperationException if there is an error occurs
     */
    SocialComponent report(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Publish the enablement resource on the specified {@link SlingHttpServletRequest}
     * @param request the client request
     * @param allowedKeys
     * @return the published {@link SocialComponent}
     * @throws OperationException if there is an error occurs
     */
    SocialComponent publish(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Delete the enablement resource on the specified {@link SlingHttpServletRequest}
     * @param request the client request
     * @param allowedKeys
     * @return the published {@link SocialComponent}
     * @throws OperationException if there is an error occurs
     */
    void delete(final SlingHttpServletRequest request) throws OperationException {
	}

}
