/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 *************************************************************************/
package com.adobe.cq.social.enablement.resource.reporting.api;

import com.adobe.cq.social.scf.SocialComponent;

/**
 * Enrollment video resource tracking interface.
 */
public interface EnablementResourceVideoTracking extends SocialComponent {

    /** Resource type of component. */
    String RESOURCE_TYPE = "social/enablement/reports/resource/videotracking";

    /**
     * @return the total number milliseconds of the video that the user has actually watched (takes into account what
     *         has been skipped)
     */
    long getProgress() {
		return 0L;
	}

    /**
     * @return the current position of the user in the video (in milliseconds)
     */
    long getResume() {
		return 0L;
	}

    /**
     * @return a state representation of the video which shows segments of the video that have been watched by the
     *         user. Each watched segment is represented by a tuple of the format [a,b] where 'a' represents the
     *         second the viewed segment started and 'b' represents the second the viewed segment finished. The state
     *         can contain one or more such segments (e.g. "[[0,5],[22,30]]" or "[0,30]")
     */
    String getState() {
		return null;
	}
}
