/*******************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *******************************************************************************/
package com.adobe.cq.social.enablement.user.api;

/**
 * The Interface UserEnrollment.
 */
public interface EnablementUserEnrollment {
    /**
     * Gets the assignment name.
     * @return the assignment name
     */
    public String getAssignmentName() {
		return null;
	}

    /**
     * Gets the resource guid.
     * @return the resource guid
     */
    public String getResourceGuid() {
		return null;
	}

    /**
     * Gets the start date.
     * @return the start date
     */
    public String getStartDate() {
		return null;
	}

    /**
     * Gets the completion status.
     * @return the completion status
     */
    public String getCompletionStatus() {
		return null;
	}

    /**
     * Gets the complete date.
     * @return
     */
    public String getCompleteDate() {
		return null;
	}

    /**
     * Gets the due status.
     * @return
     */
    public String getDueStatus() {
		return null;
	}

    /**
     * Gets the due date.
     * @return
     */
    public String getDueDate() {
		return null;
	}

    /**
     * Gets the score.
     * @return the score
     */
    public String getScore() {
		return null;
	}

    /**
     * Gets the success status.
     * @return the success status
     */
    public String getSuccessStatus() {
		return null;
	}

    /**
     * Gets the user's total number of comments on the assignment
     * @return number of comments
     */
    public int getCommentCount() {
		return 0;
	}

    /**
     * Gets the user's rating on the assignment
     * @return rating
     */
    public double getRating() {
		return 0.0d;
	}

    /**
     * Gets the asset type associated with resource.
     * @return asset type
     */
    public String getResourceAssetType() {
		return null;
	}

    /**
     * Gets the width to specify for the rating stars
     * @return rating width
     */
    public double getRatingWidth() {
		return 0.0d;
	}

    /**
     * If the completion status is a percentage, we want to render a progress bar instead of a string.
     * @return true iff the completion status is a percentage
     */
    public boolean isPercentageStatus() {
		return false;
	}

    /**
     * Determine if this enrollment is for a learning path.
     * @return true iff the enrollment is for a learning path
     */
    public boolean isLearningPath() {
		return false;
	}

    /**
     * Gets the number of resources in the learning path.
     * @return number of resources
     */
    public int getLearningPathResourceCount() {
		return 0;
	}

    /**
     * Sets the assignment name.
     * @param assignmentName the new assignment name
     */
    public void setAssignmentName(final String assignmentName) {
	}

    /**
     * Sets the resource guid.
     * @param resourceGuid the new resource guid
     */
    public void setResourceGuid(final String resourceGuid) {
	}

    /**
     * Sets the start date.
     * @param startDate the new start date
     */
    public void setStartDate(final String startDate) {
	}

    /**
     * Sets the completion status.
     * @param completionStatus the new completion status
     */
    public void setCompletionStatus(final String completionStatus) {
	}

    /**
     * Sets the score.
     * @param score the new score
     */
    public void setScore(final String score) {
	}

    /**
     * Sets the success status.
     * @param successStatus the new success status
     */
    public void setSuccessStatus(final String successStatus) {
	}

    /**
     * Sets the total number of user comments (including replies) on resource.
     * @param noOfcomments the new no comments
     */
    public void setCommentCount(final int noOfcomments) {
	}

    /**
     * Sets the user's rating.
     * @param rating the new user rating on the resource
     */
    public void setRating(final double rating) {
	}

    /**
     * Sets resource asset type.
     * @param assetType the asset type associated with resource
     */
    public void setResourceAssetType(final String assetType) {
	}

    /**
     * Sets the enrollment type.
     * @param enrollmentType -- the enrollment type associated with resource
     */
    public void setEnrollmentType(final int enrollmentType) {
	}

    /**
     * Sets the number of resources in the learning path.
     * @param count - number of resources
     */
    public void setLearningPathResourceCount(final int count) {
	}

    /**
     * Sets completion percentage for a video resource
     * @param percentComplete - indicates the % completion status
     */
    public void setPercentComplete(final String percentComplete) {
	}

    /**
     * Sets completed date for a resource
     * @param completeDate
     */
    public void setCompleteDate(final String completeDate) {
	}

    /**
     * Sets due status for a resource
     * @param dueDate
     * @param completeDate
     */
    public void setDueStatus(final String dueDate, final String completeDate) {
	}

    /**
     * Sets due date for a resource
     * @param dueDate
     * @param completeDate
     */
    public void setDueDate(String dueDate) {
	}
}
