/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.group.api;

import org.apache.sling.api.resource.ResourceResolver;

import com.adobe.cq.social.group.client.api.CommunityGroup;

public interface GroupConfigurator {

    public class GroupConfigurationException extends Exception {

        public GroupConfigurationException(final String message, final Throwable e) {
            super(message, e);
        }

        private static final long serialVersionUID = 1L;
    }

    public interface CustomGroupConfigurator {

        void configure(final CommunityGroup site, final ResourceResolver msmResolver,
            final ResourceResolver aclResolver, final ResourceResolver userManagerResolver)
            throws GroupConfigurationException {
		}
    }

    void setGroupLevelConfiguration(CommunityGroup site, ResourceResolver msmResolver, ResourceResolver aclResolver,
        ResourceResolver userManagerResolver) throws GroupConfigurationException {
	}
}
