/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.group.client.api;

import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.observation.Event;
import javax.jcr.observation.EventIterator;
import javax.jcr.observation.EventListener;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.felix.scr.annotations.Activate;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Deactivate;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.ModifiableValueMap;
import org.apache.sling.api.resource.PersistenceException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ValueMapDecorator;
import org.apache.sling.jcr.api.SlingRepository;
import org.apache.sling.jcr.resource.JcrResourceConstants;
import org.apache.sling.settings.SlingSettingsService;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.adobe.cq.social.SocialException;
import com.adobe.cq.social.blueprint.api.SiteActivationService;
import com.adobe.cq.social.community.api.CommunityConstants;
import com.adobe.cq.social.group.api.GroupConfigurator;
import com.adobe.cq.social.group.api.GroupConstants;
import com.adobe.cq.social.group.api.GroupException;
import com.adobe.cq.social.group.api.GroupConfigurator.GroupConfigurationException;
import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.SocialComponentFactory;
import com.adobe.cq.social.scf.SocialComponentFactoryManager;
import com.adobe.cq.social.serviceusers.internal.ServiceUserWrapper;
import com.adobe.cq.social.site.api.SiteConfigurator;

//import org.apache.sling.settings.SlingSettingsService;

@Service
@Component(immediate = true, metatype = false)
@Properties({@Property(name = "service.description", value = "CommunityGroup Publish Event Listener"),})
public class CommunityGroupPublishEventListener implements EventListener {

    private static final String MSM_SERVICE = "msm-service";

    private static final String USER_ADMIN = "user-admin";

    private static final String ACL_MANAGER = "acl-manager";

    private static final String TYPE_OAK_UNSTRUCTURED = "oak:Unstructured";
    private static final String SLING_RESOURCETYPE = "sling:resourceType";
    private static final String SUBSCRIPTIONS_NODE_NAME = "subscriptions";
    private static final String SUBSCRIPTIONS_RESOURCE_TYPE = "social/subscriptions/components/hbs/subscriptions";

    /** Logger for this class. */
    private static final Logger LOG = LoggerFactory.getLogger(CommunityGroupPublishEventListener.class);

    private Session userAdminSession;
    private ResourceResolver userAdminResolver;

    @Reference
    private CommunityGroupService communityGroupService;

    @Reference
    private ResourceResolverFactory resourceResolverFactory;

    @Reference
    private SlingRepository repository;

    @Reference
    private SlingSettingsService settingsService;

    @Reference
    private SocialComponentFactoryManager componentFactoryManager;

    @Reference
    private ServiceUserWrapper serviceUserWrapper;

    @Reference
    private GroupConfigurator groupConfigurator;

    private static final String[] LISTEN_TO_NODE_TYPE = {SiteActivationService.REPLICATE_NODE_TYPE};
    private static final String LISTEN_TO_NODE_PROPERTY = SiteActivationService.REPLICATE_PROPERTY_PATH;
    private static final String[] LISTEN_TO_ROOT_PATH_PUBLISH = {CommunityConstants.TENANTS_TMP_ROOT_PATH,
        CommunityConstants.COMMUNITY_TMP_ROOT_PATH + CommunityGroupConstants.ROOT_FOR_PUBLISH_COMMUNITY_NUGGETS};
    private final static List<String> LISTEN_TO_NODE_NAME = Arrays.asList(SiteActivationService.REPLICATE_NODE_NAME);

    // delimiters to split the invited id list
    private final String delimiters = "[\\s,;]+";

    @Activate
    public void activate(final ComponentContext context) throws SocialException, OperationException {
	}

    @Deactivate
    public void deactivate() {
	}

    private boolean isPublishMode() {
		return false;
	}

    @Override
    public void onEvent(final EventIterator eventIterator) {
	}

    protected void processEvent(final Event event) throws SocialException, RepositoryException, OperationException,
        PersistenceException {
		}

    private void publishCommunityGroup(final String group, final ValueMap properties) throws SocialException,
        RepositoryException, OperationException {
		}

}