/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.group.client.endpoints;

import java.util.List;
import java.util.Map;

import javax.jcr.RepositoryException;

import org.apache.sling.api.SlingHttpServletRequest;

import com.adobe.cq.social.group.client.api.CommunityGroup;
import com.adobe.cq.social.scf.Operation;
import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.OperationExtension;

public interface CommunityGroupOperationExtension extends OperationExtension<CommunityGroup> {

    public enum CommunityGroupOperation implements Operation {
        /** Create Operation. */
        CREATE, JOIN, LEAVE, INVITE, UNINVITE, PROMOTE, DEMOTE, PUBLISH, UNPUBLISH, UPDATE;
    };

    @Override
    List<CommunityGroupOperation> getOperationsToHookInto() {
		return null;
	}

    /**
     * Get any extension request parameters.
     * @param operation the operation context
     * @param request SlingHttpServletRequest
     * @param props map og values
     * @throws OperationException - thrown if not able to get params
     */
    void getExtensionRequestParameters(final Operation operation, final SlingHttpServletRequest request,
        final Map<String, Object> props) throws OperationException {
	}

    /**
     * Check if the specified parameter is a parameter that should be saved as a site configuration parameter
     * @param operation the operation context
     * @param paramName the name of the parameter
     * @return <code>true</code> if the specified parameter is a configuration that should be stored as part of the
     *         configuration.
     */
    boolean isConfigurationParameter(final Operation operation, final String paramName) {
		return false;
	}
}
