/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2017 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.moderation.spamdetector.core;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.apache.felix.scr.annotations.Activate;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Deactivate;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.resource.LoginException;
import org.apache.sling.api.resource.ResourceResolverFactory;
import org.apache.sling.settings.SlingSettingsService;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.sling.api.resource.ModifiableValueMap;
import org.apache.sling.api.resource.PersistenceException;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;

import com.adobe.cq.social.ugcbase.moderation.AutoModerationProcess;
import com.adobe.cq.social.ugcbase.moderation.AutoModerationProcessException;
import com.adobe.cq.social.serviceusers.internal.ServiceUserWrapper;
import com.adobe.g11n.ta.SpamDetector;
import com.adobe.g11n.ta.SpamResult;


@Component(label = "ProfanityFilter", description = "Automoderate UGC", immediate = true, metatype = false)
@Service(value = AutoModerationProcess.class)
public class ProfanityFilter implements AutoModerationProcess {

    private static final String JCR_DESCRIPTION = "jcr:description";
    private static final String PROP_APPROVED = "approved";
    private static final String PROP_SPAM = "isSpam";
    private static final String PROFILES = "profiles";
    private static final String COMPARE_CATEGORY = "Cat: 0";
    private static final String CRX_PATH = "/libs/settings/community/sites/moderation/spamdetector-conf/";
    private static final String SPAM_RESOURCES = "SpamResources";
    private static final String COMMUNITIES_USER_ADMIN = "communities-user-admin";

    private final Logger logger = LoggerFactory.getLogger(getClass());
    private ComponentContext context;
    private Boolean isResourceLoaded = false;
    private File resourceDir = null;

    @Reference
    private ResourceResolverFactory resourceResolverFactory;

    @Reference
    private ServiceUserWrapper serviceUserWrapper;

    @Reference
    private SlingSettingsService settingsService;

    @Activate
    protected void activate(final ComponentContext context) throws LoginException{
	}

    @Deactivate
    protected void deactivate(final ComponentContext context) {
	}

    @Override
    public void execute(final Resource resource) throws AutoModerationProcessException {
	}

    private void loadProfile() {
	}

    private void processResource(final Resource resource) throws AutoModerationProcessException {
	}

    private boolean hasProperty(final Resource resource, final String propName) {
		return false;
	}

    private <T> T getProperty(final Resource resource, final String propName, final Class<T> type) {
		return null;
	}

    private void setProperty(final Resource resource, final String propName, final Object value) {
	}
}