/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.srp.config;

/**
 * DSRP specific configuration information details.
 */
public interface DSRPConfiguration extends SocialResourceConfiguration {

    final String PN_DSRP_URI = "mysql.uri";
    final String PN_DSRP_DB = "database.name";
    final String PN_DSRP_DATASOURCE = "datasource";
    final String PN_DBTYPE = "dbtype";

    final String PN_SOLRCOLLECTION = "solr.collection";
    final String PN_SOLRURL = "solr.url";

    final String PN_ZKHOST = "zkhost";

    /**
     * Get relationalDB URI for DSRP.
     * @return host URI
     */
    String getDBURI() {
		return null;
	}

    /**
     * Get relationalDB datasource name for DSRP.
     * @return database name
     */
    String getDatasourceName() {
		return null;
	}

    /**
     * Get relationalDB name to use for the UGC storage.
     * @return collection name
     */
    String getDatabaseName() {
		return null;
	}

    /**
     * Get the type of relaional db {mysql, oracle, sqlserver, etc}
     * @return db type
     */
    String getDBType() {
		return null;
	}

    /**
     * Get Zookeeper URI.
     * @return zookeeper uri
     */
    String getZooKeeperURI() {
		return null;
	}

    /**
     * Get Solr URL.
     * @return solr url
     */
    String getSolrURL() {
		return null;
	}

    /**
     * Get Solr collection name.
     * @return solr url
     */
    String getSolrCollectionName() {
		return null;
	}

    /**
     * Get Tenant ID or default if not in a tenant.
     * @return tenantid
     */
    String getTenantId() {
		return null;
	}

}
