/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.srp.internal;

import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.apache.sling.api.SlingConstants;
import org.apache.sling.api.resource.AbstractResource;
import org.apache.sling.api.resource.ModifiableValueMap;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceMetadata;
import org.apache.sling.api.resource.ResourceResolver;
import org.apache.sling.api.resource.ValueMap;
import org.apache.sling.api.wrappers.ValueMapDecorator;

import com.adobe.cq.social.srp.SocialResourceProvider;
import com.adobe.cq.social.srp.utilities.internal.InternalSocialResourceUtilities;
import com.adobe.cq.social.srp.utilities.internal.InternalStaticResourceUtilities;

public class MapResourceImpl extends AbstractResource implements MapResource {

    private final ResourceResolver resolver;
    private final CachingResourceProvider provider;
    private final Map<String, Object> doc;
    private ResourceMetadata metadata;
    private final boolean isAttachment;
    private final String resolvedPath;
    private static final String ATTACHMENT_SUB_PATH = "attachments";
    private static final String CONTENT_SUB_PATH = "content";

    public MapResourceImpl(final ResourceResolver resolver, final CachingResourceProvider provider,
        final String resolvedPath, final Map<String, Object> doc, final boolean isAttachment) {
        this.resolver = resolver;
        this.provider = provider;
        this.doc = doc;
        this.metadata = new ResourceMetadata();
        this.metadata.setResolutionPath(resolvedPath);
        this.isAttachment = isAttachment;
        this.resolvedPath = resolvedPath;
        if (isAttachment) {
            setAttachmentMetaData();
        }
    }

    /**
     * set meta data for attachments
     */
    private void setAttachmentMetaData() {
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public Resource getParent() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getPath() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getResourceType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public String getResourceSuperType() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ResourceMetadata getResourceMetadata() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public ResourceResolver getResourceResolver() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @Override
    public SocialResourceProvider getResourceProvider() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    @SuppressWarnings("unchecked")
    @Override
    public <AdapterType> AdapterType adaptTo(final Class<AdapterType> type) {
		return null;
	}

    private Map<String, Object> applyIncrement() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public void update() {
	}

    @Override
    public Resource getRootJCRNode() {
		return null;
	}

    @Override
    public boolean isAttachment() {
		return false;
	}

    /**
     * Unlocks the metadata for this resource. When the resources are cached their metatadata needs to be unlocked
     * before being returned to the caller.
     */
    @Override
    public void unlockMetadata() {
	}

    private String getJcrAclPath() {
		return null;
	}

    public static String getAclPathGivenBase(final String path, final String providerBase) {
		return null;
	}

    @Override
    public boolean checkPermissions(final String permission) {
		return false;
	}
}
