/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *************************************************************************
 **/
package com.adobe.cq.social.subscriptions.endpoint;

import java.util.List;
import com.adobe.cq.social.scf.Operation;
import com.adobe.cq.social.scf.OperationExtension;
import com.adobe.cq.social.subscriptions.client.api.UserSubscriptionPreferences;

public interface UserPreferenceOperationExtension extends OperationExtension<UserSubscriptionPreferences> {
    /**
     * Operation types.
     */
    public enum UserPreferenceOperation implements Operation {
        /** Update operation. */
        UPDATE
    };

    /**
     * Get the list of operations that this operation extension is interested in.
     * @return a list of {@link UserProfileOperation}
     */
    @Override
    List<UserPreferenceOperation> getOperationsToHookInto() {
		return null;
	}

}
