/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.cq.social.subscriptions.endpoint;

import java.util.Map;

import javax.jcr.Session;

import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.resource.Resource;

import com.adobe.cq.social.scf.OperationException;
import com.adobe.cq.social.scf.SocialComponent;

/*
 * Interface for User Notification preference options
 */
public interface UserPreferenceOperations {
    /**
     * Update a user profile on the specified {@link SlingHttpServletRequest}.
     * @param request the client request
     * @return the update {@link UserProfile} resource
     * @throws OperationException if there is an error occurs
     */
    SocialComponent update(final SlingHttpServletRequest request) throws OperationException {
		return null;
	}

    /**
     * Update the specified user profile with the specified {@link Map} of properties.
     * @param profileResource the target user profile
     * @param props a map of the properties to be updated
     * @param session the user session to be used to perform the operation
     * @return the update {@link UserProfile} resource
     * @throws OperationException if there is an error occurs
     */
    SocialComponent update(final Resource channelPreference, final Map<String, Object> props, final Session session)
        throws OperationException {
		return null;
	}
}
