/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.adobe.cq.social.ugcbase.moderation;

/**
 * Exception thrown by an automated moderation process. The process would have encountered some error, such as
 * inconsistent data, which would prevent further execution.
 */
public class AutoModerationProcessException extends Exception {

    private static final long serialVersionUID = 1L;

    public AutoModerationProcessException() {
    }

    public AutoModerationProcessException(final String message) {
        super(message);
    }

    public AutoModerationProcessException(final Throwable cause) {
        super(cause);
    }

    public AutoModerationProcessException(final String message, final Throwable cause) {
        super(message, cause);
    }

}
