/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.socialmedia;

import aQute.bnd.annotation.ConsumerType;
import org.apache.sling.api.resource.ResourceResolver;

/**
 * Social action that will be executed after SM network redirects back to AEM.
 */

@ConsumerType
public interface SocialAction {

    /**
     * Execute method defines what actions will be executed after SM redirect.
     * @param resolver The resource resolver for the request initiated by SM network.
     * @param socialPublisher SocialPublisher instance already configured for executing SM interactions.
     * @return The redirect URL which will be called after the method finishes.
     */
    String execute(ResourceResolver resolver, SocialPublisher socialPublisher) {
		return null;
	}

}