/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.socialmedia;

import aQute.bnd.annotation.ProviderType;

/**
 * Defines a SocialPublisher which offers the possibility to interact with a SM network (ex.: post, delete)
 */
@ProviderType
public interface SocialPublisher {

    /**
     * Posts image and text to a specific location on SM Network
     *
     * @param params
     * @return Post ID
     * @throws SocialException
     */
    String publish(SocialPublisherPublishParams params) throws SocialException {
		return null;
	}

    /**
     * Delete post from SM network
     *
     * @param params
     * @throws SocialException
     */
    void delete(SocialPublisherDeleteParams params) throws SocialException {
	}


    /**
     * Set response code from Oauth in order to gain access to SM methods
     *
     * @param responseCode
     */
    void setResponseCode(String responseCode) {
	}

    /**
     * Returns the OAuth response key
     *
     * @return
     */
    String getResponseCodeKey() {
		return null;
	}
}