/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.xf;

import aQute.bnd.annotation.ProviderType;
import com.day.cq.wcm.api.Page;

import java.util.List;

/**
 * Service that provides methods to work with the Experience Fragments objects
 */
@ProviderType
public interface ExperienceFragmentsService {

    /**
     * Finds all the experience fragments variations in a given content page.
     * @param page the content page
     * @return
     */
    List<ExperienceFragmentVariation> listUsedVariations(Page page) {
		return null;
	}

    /**
     * Finds all the pages that use one or more experience fragment variations
     * @param variation one or more {@link ExperienceFragmentVariation} objects
     * @return a list of pages that contain components pointing to those experience fragments variations
     */
    List<Page> listPagesUsingVariation(ExperienceFragmentVariation... variation) {
		return null;
	}

}
