/*******************************************************************************
 * ADOBE CONFIDENTIAL
 * __________________
 *
 * Copyright 2016 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 ******************************************************************************/

package com.adobe.cq.xf.ui;

/**
 * Sling Model for the Experience Fragmnts stats component, that is displayed in the experience fragment root page properties.
 */
public interface ExperienceFragmentStats {
    /**
     * Retrieves the number of variations of this experience fragments. Essentially, this means the number of child pages.
     *
     * @return
     */
    int getNumberOfVariants() {
		return 0;
	}

    /**
     * Retrieves the number of variations of this experience fragment that can be used in websites (web variations)
     * @return
     */
    int getNumberOfWebVariants() {
		return 0;
	}

    /**
     * Retrieves the number of pages that use any web variations of this experience fragment
     * @return
     */
    int getUsageCount() {
		return 0;
	}
}
