/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2013 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.requests.logging.api;

import org.osgi.annotation.versioning.ProviderType;

/**
 * The <code>RequestLogger</code> class provides the functionality to gather
 * requests. This service is exposed in the context of the
 * {@link com.adobe.granite.requests.logging} bundle.
 */
@ProviderType
public interface RequestLogger {
    /**
     * Gets a list of the longest requests captured by the system.
     * @return a TimedRequest array of the longest requests, ordered in descending
     * order by the solve time.
     */
    TimedRequest[] getLongestRequests() {
		return null;
	}
}
