/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.security.user.ui;

import aQute.bnd.annotation.ProviderType;

/**
 * Represents an interface for datasource items related to groups and is intended to be used by UI components.
 */
@ProviderType
public interface GroupModel extends AuthorizableModel {

    /**
     * @return the group's description or {@code null} if the group doesn't have a description
     */
    String getDescription() {
		return null;
	}

    /**
     * Returns the total number of members in the group. If the number exceeds the member number limit
     * {@link com.adobe.granite.security.user.ui.impl.GroupModelImpl#MEMBER_LIMIT} the counting will stop and "2000+" will be returned.
     *
     * @return the number of members in the group
     */
    String getMembersCountEstimate() {
		return null;
	}
}
