/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.security.user.ui;

import aQute.bnd.annotation.ProviderType;

/**
 * Represents an interface for datasource items related to users and is intended to be used by UI components.
 */
@ProviderType
public interface UserModel extends AuthorizableModel {

    /**
     * @return the user's profile photo path or {@code null} if the user doesn't have a profile photo
     */
    String getPhotoPath() {
		return null;
	}

    /**
     * @return the user's profile job title or {@code null} if the user doesn't have a job title
     */
    String getJobTitle() {
		return null;
	}

    /**
     * @return {@code true} if the user is a systems user, {@code false} otherwise
     */
    boolean isSystemUser() {
		return false;
	}

    /**
     * @return {@code true} if the user is disabled, {@code false} otherwise
     */
    boolean isDisabled() {
		return false;
	}

}
