/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.security.user.util;

import com.adobe.granite.security.user.UserProperties;
import com.adobe.granite.security.user.UserPropertiesManager;
import com.adobe.granite.security.user.UserPropertiesService;
import org.apache.commons.lang3.StringUtils;
import org.apache.jackrabbit.api.security.user.Authorizable;
import org.apache.sling.api.resource.ResourceResolver;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jcr.RepositoryException;
import javax.jcr.Value;

/**
 * AuthorizableUtil...
 */
public class AuthorizableUtil {

    private static Logger log = LoggerFactory.getLogger(AuthorizableUtil.class);

    static final String FAMILY_NAME = UserPropertiesService.PROFILE_PATH + "/familyName";
    static final String GIVEN_NAME = UserPropertiesService.PROFILE_PATH + "/givenName";

    /**
     * @deprecated no longer stored in the authorizable properties but only in the profile
     */
    @Deprecated
    private static final String PROPERTY_NAME = "rep:fullname";
    /**
     * @deprecated no longer stored in the authorizable properties but only in the profile
     */
    @Deprecated
    private final static String PROPERTY_DESCRIPTION = "rep:description";

    @Deprecated
    private final static String PROPERTY_FIRST_NAME = "cq:first-name";
    /**
     * @deprecated no longer stored in the authorizable properties but only in the profile
     */
    @Deprecated
    private final static String PROPERTY_LAST_NAME = "cq:last-name";

    /**
     * Utility to retrieve the name of an authorizable that takes deprecated
     * user properties such as present in older versions if CQ into account.
     *
     * @param authorizable the authorizable
     * @return the name of the specified authorizable
     * @throws RepositoryException in case of a failure
     */
    public static String getName(Authorizable authorizable) throws RepositoryException {
		return null;
	}

    /**
     * Utility to retrieve the formatted name of a user. Always use the faster
     * {@link #getFormattedName(ResourceResolver, Authorizable)} if possible.
     *
     * @param resolver Resource resolver to use to get the <code>UserPropertiesManager</code>
     * @param userId   ID of the user to get the display name from
     * @return User's display name or its id if an error occurred
     */
    public static String getFormattedName(ResourceResolver resolver, String userId) {
		return null;
	}

    /**
     * Utility to retrieve the formatted name of a user.
     *
     * @param resolver Resource resolver to use to get the <code>UserPropertiesManager</code>
     * @param authorizable the authorizable
     * @return User's display name or its id if an error occurred
     */
    public static String getFormattedName(ResourceResolver resolver, Authorizable authorizable) {
		return null;
	}

    /**
     * Utility to retrieve the formatted name of a user. Always use the faster
     * {@link #getFormattedName(ResourceResolver, Authorizable, String)} if possible.
     *
     * @param resolver Resource resolver to use to get the <code>UserPropertiesManager</code>
     * @param userId   ID of the user to get the display name from
     * @param nameDisplayOrder  Order of given, middle and family names.
     * Western name order should be "givenName middleName familyName",
     * Eastern name order should be "familyName givenName middleName".
     * @return User's display name or its id if an error occurred
     */
    public static String getFormattedName(ResourceResolver resolver, String userId, String nameDisplayOrder) {
		return null;
	}

    /**
     * Utility to retrieve the formatted name of a user
     *
     * @param resolver Resource resolver to use to get the <code>UserPropertiesManager</code>
     * @param authorizable the authorizable
     * @param nameDisplayOrder  Order of given, middle and family names.
     * Western name order should be "givenName middleName familyName",
     * Eastern name order should be "familyName givenName middleName".
     * @return User's display name or its id if an error occurred
     */
    public static String getFormattedName(ResourceResolver resolver, Authorizable authorizable,
                                          String nameDisplayOrder) {
											return null;
										}

    private static String getFormattedName(ResourceResolver resolver, Authorizable authorizable, String userId,
                                           String nameDisplayOrder) {
											return null;
										}

    /**
     * Utility to retrieve the name of an authorizable that takes deprecated
     * user properties such as present in older versions if CQ into account.
     *
     * @param authorizable
     * @param profile
     * @return
     * @throws RepositoryException
     */
    private static String getName(Authorizable authorizable, UserProperties profile) throws RepositoryException {
		return null;
	}

    private static String getProperty(Authorizable authorizable, String propertyName) {
		return null;
	}

    private static String getProperty(Authorizable authorizable, String propertyName, String fallbackName) {
		return null;
	}
}
