/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2011 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.granite.ui.clientlibs.script;

import java.io.StringWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.jcr.Binary;
import javax.jcr.Property;
import javax.jcr.Session;

import org.apache.jackrabbit.util.Base64;
import org.apache.jackrabbit.util.Text;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * The <code>CssFileBuilder</code> provides all specific css builder functionality.
 */
public final class Utils {

    /**
     * default logger
     */
    private static final Logger log = LoggerFactory.getLogger(Utils.class);

    /**
     * pattern that matches a scheme start, e.g. "http://"
     */
    private static Pattern SCHEME_START = Pattern.compile("^[^:/]+:[^/]*/.*");

    /**
     * pattern that matches an css url reference. eg: "background: url(image.jpg);"
     */
    private static Pattern URL_PATTERN= Pattern.compile("url\\(\\s*(['\"]?)([^'\")]*)(['\"]?\\s*)\\)");


    /**
     * static class
     */
    private Utils() {
    }

    /**
     * Resolves relative links within a css, such as an url to a background image, in respect to the
     * library path.
     *
     * @param libPath the library path.
     * @param filePath the path of the original css file
     * @param css the css to transform
     * @return the transformed css
     */
    public static String rewriteUrlsInCss(String libPath, String filePath, String css) {
		return null;
	}

    /**
     * Resolves relative links within a css, such as an url to a background image, in respect to the
     * library path.
     *
     * @param libPath the library path.
     * @param filePath the path of the original css file
     * @param css the css to transform
     * @param session use to auto-inline data uris.
     * @param maxDataUriSize only inline data uris if smaller
     * @return the transformed css
     */
    public static String rewriteUrlsInCss(String libPath, String filePath, String css, Session session, long maxDataUriSize) {
		return null;
	}

    /**
     * Resolves relative links within a css, such as an url to a background image, in respect to the
     * library path.
     *
     * @param libPathSegs the library path segments.
     * @param filePathSegs the path segments of the original css file
     * @param css the css to transform
     * @param session the session to use for embedding the data
     * @param maxDataUriSize  the max size for data uris
     * @return the transformed css
     */
    public static String rewriteUrlsInCss(String[] libPathSegs, String[] filePathSegs, String css, Session session, long maxDataUriSize) {
		return null;
	}
    
    /**
     * Resolves a relative link from a css style, such as an url to a background image, in respect to the
     * library path. If the given url is absolute, it is returned unchanged.
     *
     * Note that the libPath and filePath need to be canonical in order to work correctly.
     *
     * @param libPath the library path.
     * @param filePath the path of the original css file
     * @param url the url referenced in the css file
     * @return the resolved url
     */
    public static String resolveUrl(String libPath, String filePath, String url) {
		return null;
	}
    
    /**
     * Resolves a relative link from a css style, such as an url to a background image, in respect to the
     * library path. If the given url is absolute it is returned unchanged.
     *
     * Note that the libPath and filePath need to be canonical in order to work correctly.
     *
     * @param libPath the library path.
     * @param filePath the path of the original css file
     * @param url the url referenced in the css file
     * @return the resolved url
     */
    private static String resolveUrl(String[] libPath, String[] filePath, String url) {
		return null;
	}
}
