/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.adobe.reef.siren;

import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * An {@code Entity} is a URI-addressable resource that has properties and
 * actions associated with it. It may contain sub-entities and navigational
 * links.
 */
public class Entity {

    protected String[] clazz;

    protected String[] rel;

    protected String href;

    protected String type;

    protected String title;

    protected Map<String, Object> properties = new HashMap<String,Object>();

    protected List<Entity> entities = new LinkedList<Entity>();

    protected List<Link> links = new LinkedList<Link>();

    protected List<Action> actions = new LinkedList<Action>();

    public Entity() {

    }

    /**
     * Returns the class property.
     * 
     * @return the class
     */
    public String[] getClazz() {
		return null;
	}

    /**
     * Sets the class property.
     * 
     * @param clazz the class to set
     */
    public void setClazz(String[] clazz) {
	}

    /**
     * Returns the rel property.
     * 
     * @return the rel
     */
    public String[] getRel() {
		return null;
	}

    /**
     * Sets the rel property.
     * 
     * @param rel the rel to set
     */
    public void setRel(String[] rel) {
	}

    /**
     * Returns the hef property.
     * 
     * @return the href
     */
    public String getHref() {
		return null;
	}

    /**
     * Sets the href property.
     * 
     * @param href the href to set
     */
    public void setHref(String href) {
	}

    /**
     * Returns the type property.
     * 
     * @return the type
     */
    public String getType() {
		return null;
	}

    /**
     * Sets the type property.
     * 
     * @param href the type to set
     */
    public void setType(String type) {
	}

    /**
     * Returns the title property.
     * 
     * @return the title
     */
    public String getTitle() {
		return null;
	}

    /**
     * Sets the title property.
     * 
     * @param title the title to set
     */
    public void setTitle(String title) {
	}

    /**
     * Returns the properties.
     * 
     * @return the properties
     */
    public Map<String, Object> getProperties() {
		return null;
	}

    /**
     * Sets the properties.
     * 
     * @param properties the properties to set
     */
    public void setProperties(Map<String, Object> properties) {
	}

    /**
     * Returns the sub-entities.
     * 
     * @return the entities
     */
    public List<Entity> getEntities() {
		return null;
	}

    /**
     * Sets the sub-entities.
     * 
     * @param entities the entities to set
     */
    public void setEntities(List<Entity> entities) {
	}

    /**
     * Returns the links.
     * 
     * @return the links
     */
    public List<Link> getLinks() {
		return null;
	}

    /**
     * Sets the links.
     * 
     * @param links the links to set
     */
    public void setLinks(List<Link> links) {
	}

    /**
     * Returns the actions.
     * 
     * @return the actions
     */
    public List<Action> getActions() {
		return null;
	}

    /**
     * Sets the actions.
     * 
     * @param actions the actions to set
     */
    public void setActions(List<Action> actions) {
	}

    @Override
    public String toString() {
		return null;
	}

    @Override
    public int hashCode() {
		return 0;
	}

    @Override
    public boolean equals(Object obj) {
		return false;
	}

}
