/**
 * ADOBE SYSTEMS INCORPORATED
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 * NOTICE:  Adobe permits you to use, modify, and distribute this file in accordance with the
 * terms of the Adobe license agreement accompanying it.  If you have received this file from a
 * source other than Adobe, then your use, modification, or distribution of it requires the prior
 * written permission of Adobe.
 */
package com.adobe.social.integrations.livefyre.user.api;

import com.adobe.cq.social.scf.SocialComponent;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * The user object that is used to sync with Livefyre's Ping for Pull endpoint. This differs from the normal SCF User
 * to allow more or less information to be shared with Livefyre.
 */
public interface PingForPullUser extends SocialComponent {
    /**
     * Resource type for this social component.
     */
    String RESOURCE_TYPE = "social/integrations/livefyre/pingpull/user";

    /**
     * The user's display name, which is a required field for Livefyre users.
     * @return the display name from AEM
     */
    @JsonProperty("display_name")
    String getDisplayName() {
		return null;
	}

    /**
     * Returns the email we have stored in AEM.
     * @return the email address for this user if available overwise null.
     */
    String getEmail() {
		return null;
	}

    /**
     * Image URL.
     * @return The avatar for this user on the publish site.
     */
    @JsonProperty("image_url")
    String getImageUrl() {
		return null;
	}

    /**
     * Profile URL.
     * @return The profile URL for this user on the publish site.
     */
    @JsonProperty("profile_url")
    String getProfileUrl() {
		return null;
	}

    /**
     * Settings URL. The Edit profile and profile link are the same in AEM we use ACLs to determine if you can edit
     * the profile in question.
     * @return The profile URL for this user on the publish site.
     */
    @JsonProperty("settings_url")
    String getProfileEditUrl() {
		return null;
	}
}
