package com.adobe.xmp.core.namespace;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;


/**
 * Defines prefix/namespace contract for the standard namespaces.
 */
public class DefaultPrefixContract extends HashMap<String, String>
{
	private static final long serialVersionUID = 9169953737065019512L;

	/** 
	 * A prefix to namespace map that contains the default prefixes and 
	 * namespaces from the XMP specifications.
	 */
	private static HashMap<String, String> instance;
	
	/**
	 * Private constructor
	 */
	private DefaultPrefixContract() {}

    private final static Object synchronizer = new Object();

	/**
	 * @return Returns an unmodifiable version of the prefix to namespace map.
	 */
	public static Map<String, String> getInstance()
	{
		return null;
	}

	/**
	 * Initializes the map of default prefix to namespace-mappings.
	 * <em>Note:</em> Prefixes of the form ns1, ns2... are not allowed as defaults,
	 * they are used by the NamespaceResolver.
	 */
	private static void initialize()
	{
	}
}
