/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2016 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/

package com.day.cq.dam.api.s7dam.scene7;

import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ResourceResolver;
import aQute.bnd.annotation.ProviderType;

@ProviderType
public interface ImageUrlApi {

    /**
     * Retrieve the preview server url of the asset if it is on the ips server
     * @param resource Resource for asset instance
     * @param resolver Resource's resolver
     * @return The url of the publish server
     * @deprecated
     */
     String getImageServerPreviewURL(Resource resource, ResourceResolver resolver) {
		return null;
	}

    /**
     * Retrieve the delivery server url of the asset if it is on the ips server
     * @param resource Resource for asset instance
     * @param resolver Resource's resolver
     * @return The url of the publish server
     * @deprecated
     */
     String getImageServerDeliveryURL(Resource resource, ResourceResolver resolver) {
		return null;
	}

    /**
     * Retrieve the path of the asset on the ips server
     * @param resource Resource for asset instance
     * @param resolver Resource's resolver
     * @return The path of the resource
     * @deprecated
     */
     String getImageRootPath(Resource resource, ResourceResolver resolver) {
		return null;
	}

    /**
     * Retrieve the preview server url of the asset if it is on the ips server
     * @param resource Resource for asset instance
     * @return The url of the publish server
     */
     String getImageServerPreviewURL(Resource resource) {
		return null;
	}

    /**
     * Retrieve the delivery server url of the asset if it is on the ips server
     * @param resource Resource for asset instance
     * @return The url of the publish server
     */
     String getImageServerDeliveryURL(Resource resource) {
		return null;
	}

    /**
     * Retrieve the path of the asset on the ips server
     * @param resource Resource for asset instance
     * @return The path of the resource
     */
     String getImageRootPath(Resource resource) {
		return null;
	}
}
