package com.day.cq.dam.api.s7dam.utils;

import aQute.bnd.annotation.ProviderType;

/**
 * The SampleUtils service provides calls to prepare DM sample assets and
 * presets for DMS7 integration.
 */
@ProviderType
public interface SampleUtils {

    /**
     * Copy DM sample assets from standard location to targetFolder for sync.
     *
     * The standard location is <code>/libs/dam/preview/</code>.
     *
     * @param targetFolder
     * @throws Exception
     */
    void processSampleAssets(String targetFolder) throws Exception {
	}

    /**
     * Iterate viewer presets in standard location and copy to related CSS and
     * artwork to targetFolder for sync. Update viewer preset nodes to point to
     * new CSS location.
     *
     * The standard location is <code>/etc/dam/presets/viewer/</code>.
     *
     * @param targetFolder
     * @throws Exception
     */
    void processPresetAssets(String targetFolder) throws Exception {
	}
}
