/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2015 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.dam.entitlement.api;

/**
 * This api would expose all the feature flags available and exposed by the Assets Entitlement Management.
 */
public interface EntitlementConstants {

    /*
     This feature flag signifies User's Service Level Evaluation Feature Flag.
     */
    public static final String PREMIUM_FEATURE_FLAG_PID = "com.adobe.dam.feature.flag.premium";

    /*
     This feature flag signifies Assets Collection feature.
     */
    public static final String ASSETS_COLLECTION_FEATURE_FLAG_PID = "com.adobe.dam.asset.collection.feature.flag";

    /*
    This feature flag signifies Assets Publish/Unpublish feature.
    */
    public static final String ASSETS_PUBLISH_FEATURE_FLAG_PID = "com.adobe.dam.asset.publish.feature.flag";

    /*
    This feature flag signifies Assets Lightbox feature.
    */
    public static final String ASSETS_LIGHTBOX_FEATURE_FLAG_PID = "com.adobe.dam.asset.lightbox.feature.flag";

    /*
    This feature flag signifies Assets Reports feature.
    */
    public static final String ASSETS_REPORT_FEATURE_FLAG_PID = "com.adobe.dam.asset.report.feature.flag";

    /*
    This feature flag signifies Assets workflow feature.
    */
    public static final String ASSETS_WORKFLOW_FEATURE_FLAG_PID = "com.adobe.dam.asset.workflow.feature.flag";

    /*
    This feature flag signifies Assets Processing Profile feature.
    */
    public static final String ASSETS_PROCESSINGPROFILE_FEATURE_FLAG_PID = "com.adobe.dam.asset.processingprofile.feature.flag";

    /*
    This feature flag signifies Assets Dynamic Media feature.
    */
    public static final String ASSETS_DYNAMICMEDIA_FEATURE_FLAG_PID = "com.adobe.dam.asset.dynamicmedia.feature.flag";
    
    /*
    This feature flag signifies Assets scene7 feature.
     */
    public static final String ASSETS_SCENE7_FEATURE_FLAG_PID = "com.adobe.dam.asset.scene7.feature.flag";

    /*
    This feature flag signifies Assets Dynamic Media feature.
    */
    public static final String ASSETS_LICENSED_DYNAMICMEDIA_FEATURE_FLAG_PID = "com.adobe.dam.asset.licensed.dynamicmedia.feature.flag";

    /*
    This feature flag signifies Assets Metadata Schema feature.
    */
    public static final String ASSETS_METADATASCHEMA_FEATURE_FLAG_PID = "com.adobe.dam.asset.metadataschema.feature.flag";

    /*
    This feature flag signifies Assets Search Facet feature.
    */
    public static final String ASSETS_SEARCHFACET_FEATURE_FLAG_PID = "com.adobe.dam.asset.searchfacet.feature.flag";

    /*
    This feature flag signifies Assets FTP feature.
    */
    public static final String ASSETS_FTP_FEATURE_FLAG_PID = "com.adobe.dam.asset.ftp.feature.flag";

    /*
    This feature flag signifies Assets Share feature.
    */
    public static final String ASSETS_FOLDERSHARE_FEATURE_FLAG_PID = "com.adobe.dam.asset.foldershare.feature.flag";

    /*
    This feature flag signifies Assets Private Folder feature.
    */
    public static final String ASSETS_PRIVATEFOLDER_FEATURE_FLAG_PID = "com.adobe.dam.asset.privatefolder.feature.flag";

    /*
    This feature flag signifies Assets Bulk Metadata Editor feature.
    */
    public static final String ASSETS_BULKMETADATA_FEATURE_FLAG_PID = "com.adobe.dam.asset.bulkmetadata.feature.flag";

    /*
    This feature flag signifies Assets Review Task feature.
    */
    public static final String ASSETS_REVIEW_FEATURE_FLAG_PID = "com.adobe.dam.asset.review.feature.flag";

    /*
    This feature flag signifies Assets Rendition feature.
    */
    public static final String ASSETS_RENDITION_FEATURE_FLAG_PID = "com.adobe.dam.asset.rendition.feature.flag";

    /*
    This feature flag signifies Assets Tag feature.
    */
    public static final String ASSETS_TAG_FEATURE_FLAG_PID = "com.adobe.dam.asset.tag.feature.flag";

    /*
    This feature flag signifies Assets Video feature.
    */
    public static final String ASSETS_VIDEO_FEATURE_FLAG_PID = "com.adobe.dam.asset.video.feature.flag";

    /*
    This feature flag signifies Metadata Viewer feature.
    */
    public static final String ASSETS_METADATAVIEWER_FEATURE_FLAG_PID = "com.adobe.dam.asset.metadataviewer.feature.flag";
    
    /*
    This feature flag signifies Assets Insight feature.
    */
    public static final String ASSETS_INSIGHT_FEATURE_FLAG_PID = "com.adobe.dam.asset.insight.feature.flag";

    /*
    This feature flag signifies Assets Streaming Upload feature.
    */
    public static final String ASSETS_STREAMING_UPLOAD_FEATURE_FLAG_PID = "com.adobe.dam.asset.streaming.upload.feature.flag";


}
