/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.video.servlet;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;


import javax.servlet.ServletException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Property;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


import com.day.cq.dam.api.Asset;
import com.day.cq.dam.handler.ffmpeg.ExecutableLocator;
import com.day.cq.dam.handler.ffmpeg.FFMpegWrapper;
import com.day.cq.dam.handler.ffmpeg.FfmpegNotFoundException;

/**
 * Servlet to clip video and add it as rendition.
 */
@Component
@Service
@Properties({ 
    @Property(name="sling.servlet.resourceTypes", value="sling/servlet/default"),
    @Property(name="sling.servlet.selectors", value="videoclip"),
    @Property(name="sling.servlet.methods", value="POST"),
    @Property(name="service.description", value="Servlet to clip video.")
    })
public class VideoClipServlet extends SlingAllMethodsServlet {
    private static final long serialVersionUID = -780464494271946961L;

    private final Logger log = LoggerFactory.getLogger(VideoProfileListServlet.class);
    
    private File workingDir;
    
    @Reference(policy = ReferencePolicy.STATIC)
    protected ExecutableLocator locator;
    
    @Property(value="./logs/ffmpeg")
    public static final String PROP_WORKING_DIR = "ffmpeg.workingdir";

    @Override
    protected void doPost(SlingHttpServletRequest request, SlingHttpServletResponse response) throws ServletException,
            IOException {
			}
    
    public File getWorkingDir() {
		return null;
	}
    
    private File resolveWorkingDir(String slingHome, String path) {
		return null;
	}
    
    protected void activate(ComponentContext ctx) {
	}

    /**
     * creates a temporary directory in the given dir.
     * 
     * @param parentDir parent directory in which temporary directory is to be
     *            created
     */
    protected File createTempDir(File parentDir) {
		return null;
	}

}
