/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.dam.video.servlet;

import java.awt.Dimension;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Calendar;

import javax.jcr.Binary;
import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;
import javax.jcr.ValueFormatException;
import javax.servlet.ServletException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.FilenameUtils;
import org.apache.commons.io.IOUtils;
import org.apache.felix.scr.annotations.Component;
import org.apache.felix.scr.annotations.ConfigurationPolicy;
import org.apache.felix.scr.annotations.Properties;
import org.apache.felix.scr.annotations.Reference;
import org.apache.felix.scr.annotations.ReferencePolicy;
import org.apache.felix.scr.annotations.Service;
import org.apache.felix.scr.annotations.Property;
import org.apache.jackrabbit.commons.JcrUtils;
import org.apache.sling.api.SlingHttpServletRequest;
import org.apache.sling.api.SlingHttpServletResponse;
import org.apache.sling.api.servlets.SlingAllMethodsServlet;
import org.apache.sling.commons.json.JSONException;
import org.apache.sling.commons.json.io.JSONWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.day.cq.commons.jcr.JcrConstants;
import com.day.cq.dam.handler.ffmpeg.ExecutableLocator;
import com.day.cq.dam.handler.ffmpeg.FFMpegWrapper;
import com.day.cq.dam.handler.ffmpeg.FfmpegNotFoundException;
import com.day.cq.dam.video.VideoProfile;

/**
 * Video Test Servlet
 */
@Component(policy = ConfigurationPolicy.REQUIRE)
@Service
@Properties({ 
    @Property(name="sling.servlet.resourceTypes", value="dam/components/video/profile"),
    @Property(name="sling.servlet.extensions", value="json"),
    @Property(name="sling.servlet.selectors", value="transcode.test"),
    @Property(name="sling.servlet.methods", value="GET"),
    @Property(name="service.description", value="Test a video profile.")
    })
public class VideoTestServlet extends SlingAllMethodsServlet {
    private static final long serialVersionUID = -780464494271946961L;

    private static final String NN_TEST = "test";
    private static final String PROPERTY_INPUT_FILE_NAME = "inputName";
    private static final String PROPERTY_OUTPUT_FILE_NAME = "outputName";
    private static final String PROPERTY_INPUT_DURATION = "inputDuration";
    private static final String PROPERTY_INPUT_SIZE = "inputSize";
    private static final String PROPERTY_TEST_LOG = "log";
    private static final String PROPERTY_TEST_SUCCESS = "success";
    private static final String PROPERTY_TEST_LAST_RUN = "lastRun";
    private static final String NODE_INPUT_FILE = "input";
    private static final String NODE_OUTPUT_FILE = "output";

    private static final String TMP_DIR = "videotest";

    private final Logger log = LoggerFactory.getLogger(VideoTestServlet.class);

    @Reference(policy = ReferencePolicy.STATIC)
    protected ExecutableLocator locator;

    @Override
    protected void doGet(SlingHttpServletRequest request, SlingHttpServletResponse response) throws ServletException,
            IOException {
			}

    private void storeTestResult(Node testNode, VideoTestResult testResult) throws RepositoryException,
            FileNotFoundException {
			}

    private String formatInputSize(Dimension inputSize) {
		return null;
	}

    private void writeTestResult(SlingHttpServletResponse response, VideoTestResult testResult) throws IOException,
            JSONException {
			}

    private VideoTestResult runTest(VideoProfile videoProfile, Node testNode, File tmpDir) {
		return null;
	}

    private Node getTestNode(VideoProfile videoProfile) throws RepositoryException {
		return null;
	}

}
