/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.rewriter.htmlparser;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import org.apache.felix.scr.annotations.Component;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import com.day.cq.rewriter.pipeline.Serializer;
import com.day.cq.rewriter.processor.ProcessingComponentConfiguration;
import com.day.cq.rewriter.processor.ProcessingContext;

/**
 * Writer passed on to other Sling components. Removes or marks bad links
 * in HTML data.
 * @deprecated Use the Apache Sling Html Serializer instead.
 */
@Component(factory="com.day.cq.rewriter.pipeline.Serializer/htmlwriter")
@Deprecated
public class SAXWriter implements Serializer {

    private PrintWriter delegatee;

    private List<String> emptyTags;

    private static final List<String> DEFAULT_EMPTY_TAGS;
    static {
        DEFAULT_EMPTY_TAGS = new ArrayList<String>();
        DEFAULT_EMPTY_TAGS.add("br");
        DEFAULT_EMPTY_TAGS.add("area");
        DEFAULT_EMPTY_TAGS.add("link");
        DEFAULT_EMPTY_TAGS.add("img");
        DEFAULT_EMPTY_TAGS.add("param");
        DEFAULT_EMPTY_TAGS.add("hr");
        DEFAULT_EMPTY_TAGS.add("input");
        DEFAULT_EMPTY_TAGS.add("col");
        DEFAULT_EMPTY_TAGS.add("base");
        DEFAULT_EMPTY_TAGS.add("meta");
    }

    /**
     * @see com.day.cq.rewriter.pipeline.Serializer#init(com.day.cq.rewriter.processor.ProcessingContext, com.day.cq.rewriter.processor.ProcessingComponentConfiguration)
     */
    public void init(ProcessingContext pipelineContext, ProcessingComponentConfiguration config)
    throws IOException {
	}


    /**
     * @see org.xml.sax.ContentHandler#endDocument()
     */
    public void endDocument() throws SAXException {
	}

    /*
    protected boolean checkStartElement(boolean writeEndTag) throws SAXException {
        if ( this.startElement != null ) {
            this.delegatee.write('<');
            this.delegatee.write(this.startElement);
            final String quotesString = this.atts.getValue(DocumentHandlerToSAXAdapter.NAMESPACE, DocumentHandlerToSAXAdapter.QUOTES_ATTR);
            for(int i=0; i<this.atts.getLength(); i++) {
                if ( !DocumentHandlerToSAXAdapter.NAMESPACE.equals(this.atts.getURI(i)) ) {
                    this.delegatee.write(' ');
                    this.delegatee.write(this.atts.getLocalName(i));
                    final String value = this.atts.getValue(i);
                    if ( value != null ) {
                        this.delegatee.write('=');
                        final char quoteChar;
                        if ( quotesString != null && quotesString.length() > i ) {
                            quoteChar = quotesString.charAt(i);
                        } else {
                            quoteChar = '\"';
                        }
                        this.delegatee.write(quoteChar);
                        this.delegatee.write(value);
                        this.delegatee.write(quoteChar);
                    }
                }
            }
            if ( writeEndTag ) {
                // don't close empty tags XHTML style. since we're using
                // strict HTML 4.01 which does not allow those.
                this.delegatee.write(">");
            } else {
                this.delegatee.write('>');
            }

            this.startElement = null;
            this.atts = null;
            return true;
        }
        return false;
    }
    */

    /**
     * @see org.xml.sax.ContentHandler#startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)
     */
    public void startElement(String uri, String localName, String name,
            Attributes atts) throws SAXException {
			}

    /**
     * @see org.xml.sax.ContentHandler#endElement(java.lang.String, java.lang.String, java.lang.String)
     */
    public void endElement(String uri, String localName, String name)
            throws SAXException {
			}


    /**
     * Called by HtmlParser if character data and tags are to be output for which no
     * special handling is necessary.
     *
     * @param buffer Character data
     * @param offset Offset where character data starts
     * @param length The length of the character data
     */
    public void characters(char[] buffer, int offset, int length)
    throws SAXException {
	}

    /**
     * @see org.xml.sax.ContentHandler#endPrefixMapping(java.lang.String)
     */
    public void endPrefixMapping(String prefix) throws SAXException {
	}

    /**
     * @see org.xml.sax.ContentHandler#ignorableWhitespace(char[], int, int)
     */
    public void ignorableWhitespace(char[] ch, int start, int length)
            throws SAXException {
			}

    /**
     * @see org.xml.sax.ContentHandler#processingInstruction(java.lang.String, java.lang.String)
     */
    public void processingInstruction(String target, String data)
            throws SAXException {
			}

    /**
     * @see org.xml.sax.ContentHandler#setDocumentLocator(org.xml.sax.Locator)
     */
    public void setDocumentLocator(Locator locator) {
	}

    /**
     * @see org.xml.sax.ContentHandler#skippedEntity(java.lang.String)
     */
    public void skippedEntity(String name) throws SAXException {
	}

    /**
     * @see org.xml.sax.ContentHandler#startDocument()
     */
    public void startDocument() throws SAXException {
	}


    /**
     * @see org.xml.sax.ContentHandler#startPrefixMapping(java.lang.String, java.lang.String)
     */
    public void startPrefixMapping(String prefix, String uri)
            throws SAXException {
			}
}