/*
 * Copyright 1997-2008 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.rewriter.htmlparser;

import java.io.CharArrayWriter;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.Map;
import java.util.Set;

/**
 * Tokenizes a snippet of characters into a structured tag/attribute name list.
 * @deprecated This is replaced by the Apache Sling Html parsing.
 */
@Deprecated
class TagTokenizer {
    /** Tag name buffer */
    private final CharArrayWriter tagName = new CharArrayWriter(30);

    /** Attribute name buffer */
    private final CharArrayWriter attName = new CharArrayWriter(30);

    /** Attribute value buffer */
    private final CharArrayWriter attValue = new CharArrayWriter(30);

    /** Internal property list */
    private final AttributeListImpl attributes = new AttributeListImpl();

    /** Parse state constant */
    private final static int START = 0;

    /** Parse state constant */
    private final static int TAG = START + 1;

    /** Parse state constant */
    private final static int NAME = TAG + 1;

    /** Parse state constant */
    private final static int INSIDE = NAME + 1;

    /** Parse state constant */
    private final static int ATTNAME = INSIDE + 1;

    /** Parse state constant */
    private final static int AFTER_ATTNAME = ATTNAME + 1;

    /** Parse state constant */
    private final static int EQUAL = AFTER_ATTNAME + 1;

    /** Parse state constant */
    private final static int ATTVALUE = EQUAL + 1;

    /** Parse state constant */
    private final static int STRING = ATTVALUE + 1;

    /** Parse state constant */
    private final static int ENDSLASH = STRING + 1;

    /** Parse state constant */
    private final static int END = ENDSLASH + 1;

    /** Quote character */
    private char quoteChar = '"';

    /** Flag indicating whether the tag scanned is an end tag */
    private boolean endTag;

    /** Flag indicating whether an ending slash was parsed */
    private boolean endSlash;

    /** temporary flag indicating if attribute has a value */
    private boolean hasAttributeValue;

    /** flag indicating if camelcase is to be preserved */
    private boolean preserveCamelCase = false;

    /**
     * Scan characters passed to this parser
     */
    public void tokenize(char[] buf, int off, int len) {
	}

    /**
     * Return a flag indicating whether the tag scanned was an end tag
     * @return <code>true</code> if it was an end tag, otherwise
     *         <code>false</code>
     */
    public boolean endTag() {
		return false;
	}

    /**
     * Return a flag indicating whether an ending slash was scanned
     * @return <code>true</code> if an ending slash was scanned, otherwise
     *         <code>false</code>
     */
    public boolean endSlash() {
		return false;
	}

    /**
     * Return the tagname scanned
     * @return tag name
     */
    public String tagName() {
		return null;
	}

    /**
     * Return the list of attributes scanned
     * @return list of attributes
     */
    public AttributeList attributes() {
		return null;
	}

    public void setPreserveCamelCase() {
	}

    /**
     * Reset the internal state of the tokenizer
     */
    private void reset() {
	}

    /**
     * Invoked when an attribute ends
     */
    private void attributeEnded() {
	}

    /**
     * Invoked when an attribute value starts
     */
    private void attributeValueStarted() {
	}

    /**
     * Retransfers the tokenized tag data into html again
     * @return the reassembled html string
     */
    public String toHtmlString() {
		return null;
	}
}

/**
 * Internal implementation of an <code>AttributeList</code>
 */
class AttributeListImpl implements AttributeList {

    /**
     * Internal Value class
     */
    static class Value {

        /**
         * Create a new <code>Value</code> instance
         */
        public Value(char quoteChar, String value) {
            this.quoteChar = quoteChar;
            this.value = value;
        }

        /** Quote character */
        public final char quoteChar;

        /** Value itself */
        public final String value;

        /** String representation */
        private String stringRep;

        /**
         * @see Object#toString()
         */
        public String toString() {
			return null;
		}
    }

    /** Attribute/Value pair map with case insensitives names */
    private final Map<String, Value> attributes = new LinkedHashMap<String, Value>();

    /** Attribute names, case sensitive */
    private final Set<String> attributeNames = new LinkedHashSet<String>();

    /** Flag indicating whether this object was modified */
    private boolean modified;

    /**
     * Add an attribute/value pair to this attribute list
     */
    public void addAttribute(String name, String value, char quoteChar) {
	}

    /**
     * Add an attribute/value pair to this attribute list
     */
    public void addAttribute(String name, char quoteChar) {
	}

    /**
     * Empty this attribute list
     */
    public void reset() {
	}

    /**
     * @see AttributeList#attributeCount
     */
    public int attributeCount() {
		return 0;
	}

    /**
     * @see AttributeList#attributeNames
     */
    public Iterator<String> attributeNames() {
		return null;
	}

    /**
     * @see AttributeList#containsAttribute(String)
     */
    public boolean containsAttribute(String name) {
		return false;
	}

    /**
     * @see AttributeList#getValue(String)
     */
    public String getValue(String name) {
		return null;
	}

    /**
     * @see com.day.cq.rewriter.htmlparser.AttributeList#getQuoteChar(java.lang.String)
     */
    public char getQuoteChar(String name) {
		return '0';
	}

    /**
     * @see AttributeList#getQuotedValue(String)
     */
    public String getQuotedValue(String name) {
		return null;
	}

    /**
     * @see AttributeList#setValue(String, String)
     */
    public void setValue(String name, String value) {
	}

    /**
     * @see AttributeList#removeValue(String)
     */
    public void removeValue(String name) {
	}

    /**
     * @see AttributeList#isModified
     */
    public boolean isModified() {
		return false;
	}

    /**
     * Return internal value structure
     */
    protected Value getValueEx(String name) {
		return null;
	}
}
