/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 *  Copyright 2012 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.designimporter.parser.taghandlers;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import javax.jcr.RepositoryException;

import org.apache.commons.lang3.StringEscapeUtils;
import org.ccil.cowan.tagsoup.AttributesImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.Attributes;

import com.day.cq.wcm.designimporter.DesignImportException;
import com.day.cq.wcm.designimporter.util.TagUtils;

/**
 * The default tag handler for handling all the tags the handlers for which don't exist.
 *
 * <p>
 * This tag handler simply bypasses the flow, producing the same HTML as it received via SAX events.
 * </p>
 *
 * @see com.day.cq.wcm.designimporter.parser.taghandlers.factory.DefaultTagHandlerFactory
 */
public class DefaultTagHandler extends AbstractTagHandler {

    static private Set<String> srcNormalizationTags = new HashSet<String>(Arrays.asList(new String[] { "embed", "EMBED", "source",
        "SOURCE", "video", "VIDEO" }));

    private Logger logger = LoggerFactory.getLogger(DefaultTagHandler.class);

    private Attributes atts;

    @Override
    public void beginHandling(String uri, String localName, String qName, Attributes atts) {
	}

    private void normalizeSrc(String uri, String localName, String qName, Attributes atts) {
	}

    @Override
    public void endHandling(String uri, String localName, String qName) {
	}

    protected String getStartTag(String uri, String localName, String qName, Attributes atts) {
		return null;
	}

    @Override
    public void characters(char[] ch, int start, int length) throws DesignImportException {
	}

}
