/**
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2014 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 */
package com.day.cq.wcm.foundation;

import com.adobe.cq.sightly.WCMUsePojo;
import com.day.cq.wcm.api.NameConstants;
import com.day.cq.wcm.api.TemplatedResource;
import com.day.cq.wcm.api.components.Component;
import com.day.cq.wcm.api.designer.ComponentStyle;
import com.day.cq.wcm.api.designer.Style;
import com.day.cq.wcm.commons.WCMUtils;
import org.apache.sling.api.resource.Resource;
import org.apache.sling.api.resource.ValueMap;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Use API for the responsive grid sightly component
 * /libs/wcm/foundation/components/responsivegrid
 *
 * Use {@link com.day.cq.wcm.foundation.model.responsivegrid.ResponsiveGrid} instead
 */
@Deprecated
public class ResponsiveGrid extends WCMUsePojo {

    // default config
    private final String DEFAULT_CSS_PREFIX = "aem-Grid";

    private static final int DEFAULT_COLUMNS = 12;
    private static final String BREAKPOINT_VARIANT_NAME_DEFAULT = "default";

    // private
    private String cssClassPrefix;

    // exposed
    private int columns;

    private String cssClass;

    private List<Column> paragraphs = new ArrayList<Column>();

    /**
     * Class to get the necessary properties for a column in the grid
     */
    public class Column {

        private Resource resource;
        private Map<String, Integer> gridBreakpoints;
        private String cssClass;
        private Map<String, Integer> breakpoints;
        private Set<String> columnOnlyBreakpointNames;

        private String columnCssClassPrefix;

        public Column(Resource res) {
            this.resource = res;
            this.columnCssClassPrefix = cssClassPrefix + "Column";

            createCssClass();
        }

        public Column(Resource res, Map<String, Integer> gridBreakpoints) {
            this.resource = res;
            this.gridBreakpoints = gridBreakpoints;
            this.columnCssClassPrefix = cssClassPrefix + "Column";

            createCssClass();
        }

        public Resource getResource() {
			return null;
		}

        public String getPath() {
			return null;
		}

        public Set<String> getMissingBreakpointNames() {
			return null;
		}

        public Integer getColumnCount(String breakpointName) {
			return null;
		}

        private void createCssClass() {
		}

        public String getCssClass() {
			return null;
		}

        public ValueMap getProperties() {
			return null;
		}
    }

    @Override
    public void activate() throws Exception {
	}

    /**
     * get the resource for displaying the parsys, handle templated content
     *
     * AdobePatentID="P6273-US"
     *
     * @param <T>
     * @return
     */
    public <T extends Resource> T getEffectiveResource() {
		return null;
	}

    /**
     *
     * @return css classes to be added to the markup of the grid container
     */
    public String getCssClass() {
		return null;
	}

    /**
     *
     * @return all columns added to the grid
     */
    public List<Column> getParagraphs() {
		return null;
	}
}
