/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * __________________
 *
 *  Copyright 2017 Adobe Systems Incorporated
 *  All Rights Reserved.
 *
 * NOTICE:  All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any.  The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 **************************************************************************/
package com.day.cq.wcm.foundation.model.responsivegrid.export;

import com.adobe.cq.export.json.ContainerExporter;
import com.fasterxml.jackson.annotation.JsonInclude;
import org.osgi.annotation.versioning.ProviderType;

import javax.annotation.Nullable;

/**
 * Describes the export behavior of a ResponsiveGrid.
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@ProviderType
public interface ResponsiveGridExporter extends ContainerExporter {

    /**
     * @return The CSS class names to be applied to the current grid.
     */
    @Nullable
    String getGridClassNames() {
		return null;
	}

    /**
     * @return The number of columns available for direct children in the grid.
     */
    int getColumnCount() {
		return 0;
	}
}