/*
 * Copyright 2010 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */

package com.day.cq.workflow.event;

import org.apache.sling.event.EventUtil;
import org.osgi.service.event.Event;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Map;

/**
 * A helper class to define and create external process polling events, identified using the topic {@link #EVENT_TOPIC}
 */
public class ExternalProcessPollingEvent implements Serializable {

    private static final long serialVersionUID = -2349473421221460240L;

    /**
     * The job topic for adding an entry to the audit log.
     */
    public static final String EVENT_TOPIC = "com/day/cq/workflow/external/polling/event";

    public static final String PROPERTY_POLLING_TIMEOUT = "com.day.cq.workflow.event.polling.timeout";
    public static final String PROPERTY_POLLING_ADVANCE_ON_TIMEOUT = "com.day.cq.workflow.event.polling.advanceOnTimeout";
    public static final String PROPERTY_POLLING_START = "com.day.cq.workflow.event.polling.start";
    public static final String PROPERTY_POLLING_EVENT = "com.day.cq.workflow.event.polling";
    public static final String PROPERTY_POLLING_PROCESS_ID = "com.day.cq.workflow.event.polling.process.id";

    private Map<String, Serializable> workItemMap;
    private Serializable externalProcessId;

    /**
     * Creates a new WorkflowJob.
     */
    public ExternalProcessPollingEvent(Map<String, Serializable> workItemMap, Serializable externalProcessId) {
        if (workItemMap == null) {
            throw new IllegalArgumentException("work item must not be null.");
        }
        if (externalProcessId == null) {
            throw new IllegalArgumentException("externalProcessId must not be null.");
        }
        this.workItemMap = workItemMap;
        this.externalProcessId = externalProcessId;
    }

    public Map<String, Serializable> getWorkItemMap() {
		return null;
	}


    /**
     * Convenience method to create a timed event.
     */
    public Event createPollingEvent(long period, long timeoutSeconds, boolean advanceOnTimeout) {
		return null;
	}

    /**
     * Convenience method to create a cancel timed event
     */
    public Event createPollingCancelEvent() {
		return null;
	}


}
