/*
 * Copyright 1997-2009 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.workflow.exec;

import com.day.cq.workflow.WorkflowSession;
import com.day.cq.workflow.WorkflowException;

/**
 * The <code>ParticipantChooser</code> interface is intended for impls that will
 * define the participant dynamically.
 * 
 * @deprecated Use {@link ParticipantStepChooser} instead.
 * 
 */
public interface ParticipantChooser {
    /**
     * Returns the dynamically resolved {@link java.security.Principal} id
     * 
     * @param workItem
     *            current workitem
     * @param workflowSession
     *            workflow session
     * 
     * @return the dynamically resolved {@link java.security.Principal} id
     * 
     * @deprecated Use {@link ParticipantStepChooser} instead.
     */
    String getParticipant(WorkItem workItem, WorkflowSession workflowSession, String args[]) throws WorkflowException {
		return null;
	}
}
