/*
 * Copyright 2010 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */

package com.day.cq.workflow.job;


import org.apache.sling.event.EventUtil;
import org.osgi.service.event.Event;

import java.io.Serializable;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Map;

/**
 * Helper class to identify and create external process job events, identified by job topic {@link #JOB_TOPIC}
 */
public class ExternalProcessJob implements Serializable {

    private static final long serialVersionUID = 5718625605490930738L;

    /**
     * The job topic for adding an entry to the audit log.
     */
    public static final String JOB_TOPIC = "com/day/cq/workflow/external/job";

    public static final String JOB_TOPIC_WC = "com/day/cq/workflow/external/job/*";

    /**
     * The event property holding the {@link ExternalProcessJob}.
     */
    public static final String WORKFLOW_JOB = "com.day.cq.workflow.job";

    public static final String WORKFLOW_JOB_ID = "com.day.cq.workflow.jobid";

    /**
     * The serialized {@link com.day.cq.workflow.exec.WorkItem} {@link java.util.Map} of the job.
     */
    protected Map serializedItem;

    /**
     * Creates a new WorkflowJob.
     */
    public ExternalProcessJob(Map serializedItem) {
        if (serializedItem == null) {
            throw new IllegalArgumentException("Resource must not be null.");
        }
        this.serializedItem = serializedItem;
    }

    /**
     * Returns the {@link com.day.cq.workflow.exec.WorkItem} {@link java.util.Map}of the job
     */
    public Map getWorkItemMap() {
		return null;
	}

    /**
     * Convenience method to create a job event for the workflow job.
     */
    public Event createJobEvent(Integer retryCount, String jobId) {
		return null;
	}

}
