/*
 * Copyright 2010 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 */
package com.day.cq.workflow.metadata;

import java.lang.reflect.Array;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import com.day.cq.workflow.metadata.MetaDataMap;

/**
 * A simple value map implementation, with limited conversion capabilities
 * 
 * @since 5.4
 */
public class SimpleMetaDataMap extends HashMap<String, Object> implements MetaDataMap {

    private static final long serialVersionUID = 1360764073724170383L;

    /**
     * Supports automatic meta data conversion based on the given type.
     * 
     * @see com.day.cq.workflow.metadata.MetaDataMap#get(java.lang.String,
     *      java.lang.Class)
     */
    public <T> T get(String name, Class<T> type) {
		return null;
	}

    /**
     * Supports automatic meta data conversion, based on the type of the default
     * value.
     * 
     * @see com.day.cq.workflow.metadata.MetaDataMap#get(java.lang.String,
     *      java.lang.Object)
     */
    @SuppressWarnings("unchecked")
    public <T> T get(String name, T defaultValue) {
		return null;
	}

    @SuppressWarnings("unchecked")
    private <T> T convert(Object obj, Class<T> type) {
		return null;
	}

    private <T> T[] convertToArray(Object obj, Class<T> type) {
		return null;
	}

}
