
/**
 * $Id: TempDirectory.java 12345 2004-08-22 04:56:09Z fielding $
 *
 * Copyright 1997-2004 Day Management AG
 * Barfuesserplatz 6, 4001 Basel, Switzerland
 * All Rights Reserved.
 *
 * This software is the confidential and proprietary information of
 * Day Management AG, ("Confidential Information"). You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Day.
 *
 * @version $Revision: 1.7 $, $Date: 2004-08-22 06:56:09 +0200 (Sun, 22 Aug 2004) $
 */

package com.day.io.file;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Encapsulates a temporary directory, that should work cross-platform
 * and on JDK 1.1. This is mostly useful for test code.
 * <p>
 * Note the finalize method, which should delete the directory when
 * this object is garbage collected.
 */
public class TempDirectory {
    private static final Logger log =
        LoggerFactory.getLogger(TempDirectory.class);
    private File tempDir = null;

    public TempDirectory(String name) throws IOException {
        createTempDir(name);
    }

    private void createTempDir(String name) throws IOException {
	}

    /**
     * @todo This should be recursive
     */
    public void empty() throws IOException {
	}

    /**
     * This is taken from the JDK 1.2 File class
     */
    public URL toURL() throws MalformedURLException {
		return null;
	}



    public File[] listFiles() {
		return null;
	}

    /**
     * This is useful for tests - specifically the one in com.day.io.htmlparser.TextContentListener,
     * which creates files, downloads them, and then checks them.
     */
    public File createTempFile(String fileName) throws IOException {
		return null;
	}

    public File createEmptyTempFile(String fileName) throws IOException {
		return null;
	}

    public static byte[] getBinaryTestData(int howMuch) {
		return null;
	}

    public String toString() {
		return null;
	}

    /**
     * Create a dummy binary file.  Also useful for tests.
     */
    public File createTempBinaryFile(String fileName, int size) throws IOException {
		return null;
	}

    public boolean isEmpty() {
		return false;
	}

    public void delete() throws IOException {
	}

    public File getDir() {
		return null;
	}

    public boolean containsFileName(String fileName) {
		return false;
	}

    /**
     * This should run when the TempDirectory is garbage collected - it hasn't been tested
     */
    protected void finalize() throws Throwable {
	}

}
