/*
 * Copyright 2008 ZXing authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.zxing.qrcode.encoder;

import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import com.google.zxing.qrcode.decoder.Mode;

/**
 * @author satorux@google.com (Satoru Takabayashi) - creator
 * @author dswitkin@google.com (Daniel Switkin) - ported from C++
 */
public final class QRCode {

  public static final int NUM_MASK_PATTERNS = 8;

  private Mode mode;
  private ErrorCorrectionLevel ecLevel;
  private int version;
  private int matrixWidth;
  private int maskPattern;
  private int numTotalBytes;
  private int numDataBytes;
  private int numECBytes;
  private int numRSBlocks;
  private ByteMatrix matrix;

  public QRCode() {
    mode = null;
    ecLevel = null;
    version = -1;
    matrixWidth = -1;
    maskPattern = -1;
    numTotalBytes = -1;
    numDataBytes = -1;
    numECBytes = -1;
    numRSBlocks = -1;
    matrix = null;
  }

  // Mode of the QR Code.
  public Mode getMode() {
	return null;
}

  // Error correction level of the QR Code.
  public ErrorCorrectionLevel getECLevel() {
	return null;
}

  // Version of the QR Code.  The bigger size, the bigger version.
  public int getVersion() {
	return 0;
}

  // ByteMatrix width of the QR Code.
  public int getMatrixWidth() {
	return 0;
}

  // Mask pattern of the QR Code.
  public int getMaskPattern() {
	return 0;
}

  // Number of total bytes in the QR Code.
  public int getNumTotalBytes() {
	return 0;
}

  // Number of data bytes in the QR Code.
  public int getNumDataBytes() {
	return 0;
}

  // Number of error correction bytes in the QR Code.
  public int getNumECBytes() {
	return 0;
}

  // Number of Reedsolomon blocks in the QR Code.
  public int getNumRSBlocks() {
	return 0;
}

  // ByteMatrix data of the QR Code.
  public ByteMatrix getMatrix() {
	return null;
}
  

  // Return the value of the module (cell) pointed by "x" and "y" in the matrix of the QR Code. They
  // call cells in the matrix "modules". 1 represents a black cell, and 0 represents a white cell.
  public int at(int x, int y) {
	return 0;
}

  // Checks all the member variables are set properly. Returns true on success. Otherwise, returns
  // false.
  public boolean isValid() {
	return false;
}

  // Return debug String.
  @Override
  public String toString() {
	return null;
}

  public void setMode(Mode value) {
}

  public void setECLevel(ErrorCorrectionLevel value) {
}

  public void setVersion(int value) {
}

  public void setMatrixWidth(int value) {
}

  public void setMaskPattern(int value) {
}

  public void setNumTotalBytes(int value) {
}

  public void setNumDataBytes(int value) {
}

  public void setNumECBytes(int value) {
}

  public void setNumRSBlocks(int value) {
}

  // This takes ownership of the 2D array.
  public void setMatrix(ByteMatrix value) {
}

  // Check if "mask_pattern" is valid.
  public static boolean isValidMaskPattern(int maskPattern) {
	return false;
}

}
