/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.oak.commons.cache;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

public class Cache<K, V extends Cache.Value> {

    int maxMemoryBytes;
    AtomicInteger memoryUsed = new AtomicInteger();
    private final Backend<K, V> backend;

    private final Map<K, V> map = new LinkedHashMap<K, V>(1024, 0.75f, true) {

        private static final long serialVersionUID = 1L;

        @Override
        protected boolean removeEldestEntry(Map.Entry<K, V> eldest) {
			return false;
		}

    };

    private Cache(Backend<K, V> backend, int maxMemoryBytes) {
        this.backend = backend;
        this.maxMemoryBytes = maxMemoryBytes;
    }

    public void put(K key, V value) {
	}

    /**
     * Get the element in the cache if one exists, or add it to the cache if not.
     *
     * @param key the key
     * @param value the value
     * @return the cached element
     */
    public V replace(K key, V value) {
		return null;
	}

    public V get(K key) {
		return null;
	}

    /**
     * A cacheable object.
     */
    public interface Value {

        /**
         * Get the memory required in bytes. The method must always return the
         * same value once the element is in the cache.
         *
         * @return the memory used in bytes
         */
        int getMemory() {
			return 0;
		}

    }

    /**
     * A cache backend that can load objects from persistent storage.
     *
     * @param <K> the key class
     * @param <V> the value class
     */
    public interface Backend<K, V> {

        /**
         * Load the object. The method does not need to be synchronized
         * (it is synchronized in the cache)
         *
         * @param key the key
         * @return the value
         */
        V load(K key) {
			return null;
		}

    }

    public static <K, V extends Cache.Value> Cache<K, V> newInstance(Backend<K, V> backend, int maxMemoryBytes) {
		return null;
	}

    public void clear() {
	}

    public int size() {
		return 0;
	}

    public int getMemoryUsed() {
		return 0;
	}

    public int getMemoryMax() {
		return 0;
	}

}
