/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.jackrabbit.oak.plugins.blob.datastore;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.util.Arrays;

import org.apache.jackrabbit.core.data.DataIdentifier;
import org.apache.jackrabbit.core.data.DataRecord;
import org.apache.jackrabbit.core.data.DataStoreException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Represents binary data which is backed by a byte[] (in memory).
 */
public class InMemoryDataRecord implements DataRecord {

    /**
     * Logger instance for this class
     */
    private static Logger log = LoggerFactory.getLogger(InMemoryDataRecord.class);

    /**
     * the prefix of the string representation of this value
     */
    private static final String PREFIX = "0x";

    /**
     * the data
     */
    private final byte[] data;

    private DataIdentifier identifier;

    /**
     * empty array
     */
    private static final byte[] EMPTY_BYTE_ARRAY = new byte[0];

    /**
     * empty instance
     */
    private static final InMemoryDataRecord EMPTY = new InMemoryDataRecord(EMPTY_BYTE_ARRAY);

    /**
     * Creates a new instance from a
     * <code>byte[]</code> array.
     *
     * @param data the byte array
     */
    private InMemoryDataRecord(byte[] data) {
        this.data = data;
    }

    /**
     * Creates a new instance from a
     * <code>byte[]</code> array.
     *
     * @param data the byte array
     */
    static InMemoryDataRecord getInstance(byte[] data) {
		return null;
	}

    /**
     * Checks if String can be converted to an instance of this class.
     * @param id DataRecord identifier
     * @return true if it can be converted
     */
    public static boolean isInstance(String id) {
		return false;
	}

    /**
     * Convert a String to an instance of this class.
     * @param id DataRecord identifier
     * @return the instance
     */
    public static InMemoryDataRecord getInstance(String id) throws IllegalArgumentException {
		return null;
	}

    @Override
    public DataIdentifier getIdentifier() {
		return null;
	}

    @Override
    public String getReference() {
		return null;
	}

    @Override
    public long getLength() throws DataStoreException {
		return 0L;
	}

    public InputStream getStream() {
		return null;
	}

    @Override
    public long getLastModified() {
		return 0L;
	}

    public String toString() {
		return null;
	}

    public boolean equals(Object obj) {
		return false;
	}

    /**
     * Returns zero to satisfy the Object equals/hashCode contract.
     * This class is mutable and not meant to be used as a hash key.
     *
     * @return always zero
     * @see Object#hashCode()
     */
    public int hashCode() {
		return 0;
	}
}
