/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.name;

import javax.jcr.RepositoryException;

import org.apache.jackrabbit.spi.Name;
import org.apache.jackrabbit.spi.Path;

final class NamePath extends RelativePath {

    /** Serial version UID */
    private static final long serialVersionUID = -2887665244213430950L;

    /**
     * Name of the last path element.
     */
    private final Name name;

    /**
     * Optional index of the last path element. Set to
     * {@link Path#INDEX_UNDEFINED} if not explicitly specified,
     * otherwise contains the 1-based index.
     */
    private final int index;

    public NamePath(Path parent, Name name, int index) {
        super(parent);
        assert name != null;
        assert index >= 0;
        this.name = name;
        this.index = index;
    }

    protected int getDepthModifier() {
		return 0;
	}

    protected Path getParent() throws RepositoryException {
		return null;
	}

    protected String getElementString() {
		return null;
	}

    public Name getName() {
		return null;
	}

    @Override
    public int getIndex() {
		return 0;
	}

    @Override
    public int getNormalizedIndex() {
		return 0;
	}

    /**
     * Returns <code>true</code> as this path ends in a named element.
     *
     * @return <code>true</code>
     */
    @Override
    public boolean denotesName() {
		return false;
	}

    public boolean isCanonical() {
		return false;
	}

    public boolean isNormalized() {
		return false;
	}

    public Path getNormalizedPath() throws RepositoryException {
		return null;
	}

    public Path getCanonicalPath() throws RepositoryException {
		return null;
	}

    /**
     * Returns the last element of this path.
     *
     * @return last element of this path
     */
    @Override
    public AbstractPath getLastElement() {
		return null;
	}

    //--------------------------------------------------------------< Object >

    @Override
    public final boolean equals(Object that) {
		return false;
	}

    @Override
    public final int hashCode() {
		return 0;
	}

}
