/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.nodetype.constraint;

import javax.jcr.NamespaceException;
import javax.jcr.PropertyType;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.ConstraintViolationException;

import org.apache.jackrabbit.spi.Path;
import org.apache.jackrabbit.spi.QValue;
import org.apache.jackrabbit.spi.PathFactory;
import org.apache.jackrabbit.spi.commons.conversion.NameException;
import org.apache.jackrabbit.spi.commons.conversion.NamePathResolver;
import org.apache.jackrabbit.spi.commons.conversion.PathResolver;
import org.apache.jackrabbit.spi.commons.name.PathFactoryImpl;
import org.apache.jackrabbit.spi.commons.name.NameConstants;
import org.apache.jackrabbit.spi.commons.nodetype.InvalidConstraintException;

/**
 * <code>PathConstraint</code> ...
 */
class PathConstraint extends ValueConstraint {

    static final String WILDCARD = Path.DELIMITER + NameConstants.ANY_NAME.toString();
    static final String JCR_WILDCARD = "/*";
    // TODO improve. don't rely on a specific factory impl
    private static final PathFactory PATH_FACTORY = PathFactoryImpl.getInstance();

    private final Path path;
    private final boolean deep;

    static PathConstraint create(String pathString) {
		return null;
	}

    static PathConstraint create(String jcrPath, PathResolver resolver)
            throws InvalidConstraintException {
				return null;
			}

    private PathConstraint(String pathString, Path path, boolean deep) {
        super(pathString);
        this.path = path;
        this.deep = deep;
    }

    /**
     * Uses {@link NamePathResolver#getJCRPath(Path)} to convert the
     * <code>Path</code> present with this constraint into a JCR path.
     *
     * @see ValueConstraint#getDefinition(NamePathResolver)
     * @param resolver name-path resolver
     */
    @Override
    public String getDefinition(NamePathResolver resolver) {
		return null;
	}

    /**
     * @see org.apache.jackrabbit.spi.QValueConstraint#check(QValue)
     */
    public void check(QValue value) throws ConstraintViolationException, RepositoryException {
	}

}
