/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.query;

import java.util.Collection;

import org.apache.jackrabbit.spi.Name;

/**
 * Default implementation of a {@link QueryNodeFactory}.
 */
public class DefaultQueryNodeFactory implements QueryNodeFactory {

    /**
     * Valid node type names under /jcr:system
     */
    private final Collection<Name> validJcrSystemNodeTypeNames;

    /**
     * Creates a DefaultQueryNodeFactory with the given node types under
     * /jcr:system .
     */
    public DefaultQueryNodeFactory(
            Collection<Name> validJcrSystemNodeTypeNames) {
        this.validJcrSystemNodeTypeNames = validJcrSystemNodeTypeNames;
    }

    /**
     * {@inheritDoc}
     */
    public NodeTypeQueryNode createNodeTypeQueryNode(QueryNode parent,
                                                     Name nodeType) {
														return null;
													}

    /**
     * {@inheritDoc}
     */
    public AndQueryNode createAndQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public LocationStepQueryNode createLocationStepQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public DerefQueryNode createDerefQueryNode(QueryNode parent,
                                               Name nameTest,
                                               boolean descendants) {
												return null;
											}

    /**
     * {@inheritDoc}
     */
    public NotQueryNode createNotQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public OrQueryNode createOrQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public RelationQueryNode createRelationQueryNode(QueryNode parent,
                                                     int operation) {
														return null;
													}

    /**
     * {@inheritDoc}
     */
    public PathQueryNode createPathQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public OrderQueryNode createOrderQueryNode(QueryNode parent) {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public PropertyFunctionQueryNode createPropertyFunctionQueryNode(
            QueryNode parent, String functionName) {
				return null;
			}

    /**
     * {@inheritDoc}
     */
    public QueryRootNode createQueryRootNode() {
		return null;
	}

    /**
     * {@inheritDoc}
     */
    public TextsearchQueryNode createTextsearchQueryNode(QueryNode parent,
                                                         String query) {
															return null;
														}
}
