/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.jackrabbit.stats;

import static java.util.Arrays.fill;

import org.apache.jackrabbit.api.stats.TimeSeries;

/**
 * Time series of the maximum value recorded in a period
 */
public class TimeSeriesMax implements TimeSeries {
    private final MaxValue max;
    private final long missingValue;
    private final long[] perSecond;
    private final long[] perMinute;
    private final long[] perHour;
    private final long[] perWeek;

    /** Current second (index in {@link #perSecond}) */
    private int seconds;

    /** Current minute (index in {@link #perMinute}) */
    private int minutes;

    /** Current hour (index in {@link #perHour}) */
    private int hours;

    /** Current week (index in {@link #perWeek}) */
    private int weeks;

    public TimeSeriesMax() {
        this(0);
    }

    public TimeSeriesMax(long missingValue) {
        this.missingValue = missingValue;
        max = new MaxValue(missingValue);
        perSecond = newArray(60, missingValue);
        perMinute = newArray(60, missingValue);
        perHour = newArray(7 * 24, missingValue);
        perWeek = newArray(3 * 52, missingValue);
    }

    private static long[] newArray(int size, long value) {
		return null;
	}

    public void recordValue(long value) {
	}

    /**
     * Records the number of measured values over the past second and resets
     * the counter. This method should be scheduled to be called once per
     * second.
     */
    public synchronized void recordOneSecond() {
	}

    @Override
    public long getMissingValue() {
		return 0L;
	}

    @Override
    public synchronized long[] getValuePerSecond() {
		return null;
	}

    @Override
    public synchronized long[] getValuePerMinute() {
		return null;
	}

    @Override
    public synchronized long[] getValuePerHour() {
		return null;
	}

    @Override
    public synchronized long[] getValuePerWeek() {
		return null;
	}

    /**
     * Returns the maximum of all entries in the given array.
     */
    private long max(long[] array) {
		return 0L;
	}

    /**
     * Returns a copy of the given cyclical array, with the element at
     * the given position as the first element of the returned array.
     *
     * @param array cyclical array
     * @param pos position of the first element
     * @return copy of the array
     */
    private static long[] cyclicCopyFrom(long[] array, int pos) {
		return null;
	}

    private class MaxValue {
        private long max;

        public MaxValue(long max) {
            this.max = max;
        }

        public synchronized long getAndSetValue(long value) {
			return 0L;
		}

        public synchronized void setIfMaximal(long value) {
		}
    }
}
