/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.sling.provisioning.model;

import static org.apache.sling.provisioning.model.ModelResolveUtility.getProcessedConfiguration;
import static org.apache.sling.provisioning.model.ModelResolveUtility.replace;
import static org.apache.sling.provisioning.model.ModelResolveUtility.resolveArtifactVersion;

import java.util.Map.Entry;

import org.apache.sling.provisioning.model.ModelUtility.ResolverOptions;
import org.apache.sling.provisioning.model.ModelUtility.VariableResolver;

/**
 * Resolves all variables and artifact dependencies for the {@link ModelUtility#getEffectiveModel(Model)} method.
 */
class EffectiveModelProcessor extends ModelProcessor {

    private final ResolverOptions options;

    public EffectiveModelProcessor(ResolverOptions options) {
        if (options == null) {
            throw new IllegalArgumentException("Resolver options is null");
        }
        this.options = options;
    }

    @Override
    protected Artifact processArtifact(Artifact artifact, Feature newFeature, RunMode newRunMode) {
		return null;
	}

    @Override
    protected Configuration processConfiguration(Configuration config, Feature newFeature, RunMode newRunMode) {
		return null;
	}

    @Override
    protected KeyValueMap<String> processSettings(KeyValueMap<String> settings, final Feature newFeature, final RunMode newRunMode) {
		return null;
	}

}
