/*******************************************************************************
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.apache.sling.scripting.sightly.compiler.commands;

import java.util.Stack;

import org.apache.sling.scripting.sightly.impl.compiler.visitor.UniformVisitor;

/**
 * This {@link CommandVisitor} allows storing states for {@link Command} evaluation.
 */
public final class StatefulVisitor implements CommandVisitor {

    private final Stack<CommandVisitor> stack = new Stack<CommandVisitor>();
    private CommandVisitor visitor;
    private StateControl control = new StateControl();

    public StatefulVisitor() {
        this.visitor = InvalidState.INSTANCE;
    }

    public StateControl getControl() {
		return null;
	}

    public void initializeWith(CommandVisitor initialState) {
	}

    @Override
    public void visit(Conditional.Start conditionalStart) {
	}

    @Override
    public void visit(Conditional.End conditionalEnd) {
	}

    @Override
    public void visit(VariableBinding.Start variableBindingStart) {
	}

    @Override
    public void visit(VariableBinding.End variableBindingEnd) {
	}

    @Override
    public void visit(VariableBinding.Global globalAssignment) {
	}

    @Override
    public void visit(OutputVariable outputVariable) {
	}

    @Override
    public void visit(OutText outText) {
	}

    @Override
    public void visit(Loop.Start loopStart) {
	}

    @Override
    public void visit(Loop.End loopEnd) {
	}

    @Override
    public void visit(Procedure.Start startProcedure) {
	}

    @Override
    public void visit(Procedure.End endProcedure) {
	}

    @Override
    public void visit(Procedure.Call procedureCall) {
	}

    private void pushVisitor(CommandVisitor visitor) {
	}

    private CommandVisitor popVisitor() {
		return null;
	}

    public final class StateControl {

        public void push(CommandVisitor visitor) {
		}

        public CommandVisitor pop() {
			return null;
		}

        public CommandVisitor replace(CommandVisitor visitor) {
			return null;
		}
    }

    private static final class InvalidState extends UniformVisitor {

        public static final InvalidState INSTANCE = new InvalidState();

        private InvalidState() {
        }

        @Override
        public void onCommand(Command command) {
		}
    }
}
